<?php

namespace Sites\CamSoda;

function get_shortname()
{
    return 'cs';
}

function online_status()
{
	global $_AVOS;

    $url = "https://feed.camsoda.com/api/v1/browse/online_embed?id=ID_HERE&type=revs";

	$raw = @file_get_contents($url);
	$json = json_decode($raw);
	$models = array();
    $chk = [];

    foreach ($json->results as $m) {

            $languages = array();
            foreach ($m->language as $l) {
                $languages[] = \Avos\Utils\languageCode($l);
            }
            $languages = implode(',', $languages);

			$models[] = array(
                'site' => 'cs',
                'externalId' => (int)$m->user_id,
				'nickname' => $m->username,
                'name' => \Avos\Utils\convert_ascii($m->name),
                'gender' => $m->gender,
                'subject' => $m->subject,
                'imageUrl' => $m->thumb,
                'viewers' => (int)$m->viewers,
				'followers' => (int)$m->followers,
				'tags' => implode(',', \Avos\Utils\convert_ascii($m->tags)),
                'languages' => $languages,
                'earnedForGoal' => 0, // Replace with actual value if available
                'neededForGoal' => 0, // Replace with actual value if available
                'broadcastVR' => 0 ,// Replace with actual value if available
                
				'status' => str_replace(
								array('online', 'private', 'limited'),
								array('f', 'p', 'a'),
								$m->status),
            );

            #$chk[$m->status] = 1;
            #$chk[$m->gender] = 1;
    }

    #print_r(array_keys($chk));
    #echo count($models) . "\n";

	return $models;
}

function scrape_models($num, $min, $max)
{
    \Avos\Cron\debug("camsoda: scraping max $num models");
    $oldest = time() - getConfig('webcams', 'scrapeInterval', 30) * 86400;
    $models = \Avos\Database\queryAssoc("SELECT id, nickname FROM webcams WHERE scrapedOn < $oldest AND site='cs' ORDER BY updatedOn DESC LIMIT $num");

    foreach ($models as $i => $m) {

        $rm = array('id' => $m['id']);
        $html = file_get_contents("https://www.camsoda.com/$m[nickname]");

        preg_match_all('!bio-module__detailListLabel\-\-\w+">(.*?)<.*?<div>(.*?)</div>!', $html, $c);

        foreach ($c[1] as $i => $name) {
            $attr[$name] = html_entity_decode($c[2][$i]);
            $attr[$name] = iconv('UTF-8', 'ASCII//TRANSLIT', $c[2][$i]);
        }

        // unused: Smoke / Drink

        if (!empty($attr['Age'])) {
            $rm['age'] = $attr['Age'];
        }

        if (!empty($attr['Location'])) {
            $rm['location'] = $attr['Location'];
        }

        if (!empty($attr['Body Type'])) {
            $rm['body'] = substr($attr['Body Type'], 0, 32);
        }

        /*
        if (!empty($attr['Hair Color'])) {
            $rm['hair'] = substr($attr['Hair Color'], 0, 32);
        }

        if (!empty($attr['Eye Color'])) {
            $rm['eyes'] = substr($attr['Eye Color'], 0, 32);
        }


        if (!empty($attr['Body Decorations'])) {
            $rm['bodyx'] = substr($attr['Body Decorations'], 0, 32);
        }
         */

        if (count($rm) > 1) {
            $sql = "UPDATE webcams SET ";
            foreach ($rm as $k => $v) {
                if ($k != 'id') {
                    $sql .= $k . '=' . \Avos\Database\quote($v) . ',';
                }
            }
            $sql .= "scrapedOn=UNIX_TIMESTAMP() WHERE id=$rm[id]";
            \Avos\Cron\debug($sql);
            \Avos\Database\query($sql);

            $sql = str_replace('UPDATE webcams', 'UPDATE webcamsArchive', $sql);
            \Avos\Database\query($sql);
        }

        sleep(rand($min, $max));
    }

}

