#!/bin/bash

# Define the list of databases and their credentials
declare -A databases
databases=(
    ["awstrip"]="awstrip awstrip localhost 3306"
    ["awboobs"]="awboobs awboobs localhost 3306"
    ["girlstochat"]="girlstochat girlstochat localhost 3306"
    ["chatstripgirls"]="chatstripgirls chatstripgirls localhost 3306"
    ["chatstripcum"]="chatstripcum chatstripcum localhost 3306"
    ["chatstripsex"]="chatstripsex chatstripsex localhost 3306"
    ["camscasting"]="camscasting camscasting localhost 3306"
    ["teencums"]="teencums teencums localhost 3306"
    ["testavos"]="testavos testavos localhost 3306"
    ["avos"]="avos avos localhost 3306"
    ["awpussy"]="awpussy awpussy localhost 3306"
    ["wetpussygirls"]="wetpussygirls wetpussygirls localhost 3306"
)

# SQL query to alter the tables
SQL_QUERY="ALTER TABLE videosTags MODIFY COLUMN name VARCHAR(60) NOT NULL; ALTER TABLE photosTags MODIFY COLUMN name VARCHAR(60) NOT NULL;"

# Function to update database
update_database() {
    local db=$1
    local user=$2
    local password=$3
    local host=$4
    local port=$5

    echo "Modifying database: $db on host: $host with user: $user"

    # Execute the SQL query on the current database
    mysql -u "$user" -p"$password" -h "$host" -P "$port" -e "USE $db; $SQL_QUERY"

    if [ $? -eq 0 ]; then
        echo "Database $db modified successfully."
    else
        echo "Failed to modify database $db."
    fi
}

# Loop through each database and apply the changes
for db in "${!databases[@]}"; do
    IFS=' ' read -r user password host port <<< "${databases[$db]}"
    update_database "$db" "$user" "$password" "$host" "$port"
done

echo "Database modification completed."
