-- MySQL dump 10.19  Distrib 10.3.31-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: avos
-- ------------------------------------------------------
-- Server version	10.3.31-MariaDB-0+deb10u1

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `dailyStats`
--

DROP TABLE IF EXISTS `dailyStats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dailyStats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `webcamsId` int(10) unsigned NOT NULL,
  `day` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `month` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `year` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `awayTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `awaySessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `awayTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTime` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `year_month_day_webcamsId_idx` (`year`,`month`,`day`,`webcamsId`)
) ENGINE=InnoDB AUTO_INCREMENT=314440 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `der`
--

DROP TABLE IF EXISTS `der`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `der` (
  `id` int(6) unsigned NOT NULL AUTO_INCREMENT,
  `username` varchar(100) NOT NULL,
  `age` varchar(100) NOT NULL,
  `gender` varchar(100) NOT NULL,
  `image` varchar(250) NOT NULL,
  `language` varchar(100) NOT NULL,
  `location` varchar(100) NOT NULL,
  `Birth` varchar(100) NOT NULL,
  `time_online` varchar(100) NOT NULL,
  `followers` varchar(100) NOT NULL,
  `room_users` varchar(100) NOT NULL,
  `status` varchar(100) NOT NULL,
  `hd` varchar(100) NOT NULL,
  `tags` varchar(100) NOT NULL,
  `new` varchar(100) NOT NULL,
  `subject` text NOT NULL,
  `iframe` varchar(1000) DEFAULT NULL,
  `reg_date` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=8781 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `history`
--

DROP TABLE IF EXISTS `history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `history` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `webcamsId` int(10) unsigned NOT NULL,
  `epochTime` int(11) unsigned NOT NULL DEFAULT 0,
  `status` enum('o','a','f','g','p') NOT NULL DEFAULT 'f',
  `statusTime` int(10) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `webcamsId_statusTime_idx` (`webcamsId`,`statusTime`),
  KEY `webcamsId_idx` (`webcamsId`),
  KEY `processed_statusTime_idx` (`statusTime`),
  KEY `webcamsId_epochTime_idx` (`webcamsId`,`epochTime`),
  KEY `statusTime_idx` (`statusTime`)
) ENGINE=InnoDB AUTO_INCREMENT=33066156 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `monthlyStats`
--

DROP TABLE IF EXISTS `monthlyStats`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `monthlyStats` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `webcamsId` int(10) unsigned NOT NULL,
  `day` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `month` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `year` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `awayTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `awaySessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `awayTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `freechatSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `freechatTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `groupSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `groupTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTime` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `privateSessions` smallint(5) unsigned NOT NULL DEFAULT 0,
  `privateTimeMax` smallint(5) unsigned NOT NULL DEFAULT 0,
  PRIMARY KEY (`id`),
  KEY `year_month_webcamsId_idx` (`year`,`month`,`webcamsId`)
) ENGINE=InnoDB AUTO_INCREMENT=123782 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `photos`
--

DROP TABLE IF EXISTS `photos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `photos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `views` smallint(5) unsigned NOT NULL DEFAULT 0,
  `title` varchar(64) NOT NULL,
  `urlTitle` varchar(64) NOT NULL DEFAULT '',
  `tags` varchar(256) NOT NULL DEFAULT '',
  `description` varchar(2048) NOT NULL DEFAULT '',
  `folder` varchar(128) NOT NULL,
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `publishedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `viewedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `numPhotos` smallint(5) unsigned NOT NULL DEFAULT 1,
  `mainPhoto` smallint(5) unsigned NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`),
  KEY `publishedOn_idx` (`publishedOn`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `photosActions`
--

DROP TABLE IF EXISTS `photosActions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `photosActions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `photosId` int(10) unsigned NOT NULL,
  `action` enum('rename','delete') NOT NULL,
  `title` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `photosTags`
--

DROP TABLE IF EXISTS `photosTags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `photosTags` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(12) NOT NULL,
  `photosId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`photosId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `videos`
--

DROP TABLE IF EXISTS `videos`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `videos` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `processed` tinyint(1) NOT NULL DEFAULT 0,
  `views` smallint(5) unsigned NOT NULL DEFAULT 0,
  `title` varchar(128) DEFAULT NULL,
  `urlTitle` varchar(128) DEFAULT NULL,
  `tags` varchar(256) NOT NULL DEFAULT '',
  `description` varchar(2048) NOT NULL DEFAULT '',
  `filename` varchar(128) NOT NULL,
  `duration` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `width` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `height` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `aspect_ratio` varchar(8) NOT NULL DEFAULT '16:9',
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `publishedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `viewedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `mainThumb` smallint(5) unsigned NOT NULL DEFAULT 1,
  PRIMARY KEY (`id`),
  KEY `publishedOn_idx` (`publishedOn`)
) ENGINE=InnoDB AUTO_INCREMENT=290 DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `videosActions`
--

DROP TABLE IF EXISTS `videosActions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `videosActions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `videosId` int(10) unsigned NOT NULL,
  `action` enum('rename','delete') NOT NULL,
  `title` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `videosTags`
--

DROP TABLE IF EXISTS `videosTags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `videosTags` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(12) NOT NULL,
  `videosId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`videosId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcams`
--

DROP TABLE IF EXISTS `webcams`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webcams` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `updatedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `nickname` varchar(128) NOT NULL,
  `externalId` int(10) unsigned NOT NULL DEFAULT 0,
  `name` varchar(128) NOT NULL,
  `site` enum('cb','sc','bc','ff','sr','lj','sm') NOT NULL,
  `status` enum('o','a','f','g','p') NOT NULL DEFAULT 'o',
  `statusTime` int(11) unsigned NOT NULL DEFAULT 0,
  `subject` varchar(255) NOT NULL DEFAULT '',
  `age` tinyint(3) unsigned NOT NULL DEFAULT 18,
  `imageUrl` varchar(128) NOT NULL DEFAULT '',
  `lastImageTime` int(10) unsigned NOT NULL DEFAULT 0,
  `numImages` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `viewers` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `followers` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `gender` enum('c','f','m','t') NOT NULL DEFAULT 'f',
  `hd` tinyint(1) NOT NULL DEFAULT 0,
  `rank` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `genderRank` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `tags` varchar(2048) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `nickname_site_idx` (`nickname`,`site`),
  KEY `statusTime_site_idx` (`statusTime`,`site`),
  KEY `site_lastImageTime` (`site`,`lastImageTime`),
  KEY `site_idx` (`site`),
  KEY `site_status_idx` (`site`,`status`),
  KEY `status_site_id` (`status`,`site`),
  KEY `tags_idx` (`tags`),
  KEY `status_tags_idx` (`status`,`tags`),
  KEY `status_site_rank_idx` (`status`,`site`,`rank`),
  KEY `status_site_rank_id_idx` (`status`,`site`,`rank`,`id`),
  KEY `status_idx` (`status`)
) ENGINE=InnoDB AUTO_INCREMENT=374704 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcamsArchive`
--

DROP TABLE IF EXISTS `webcamsArchive`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webcamsArchive` (
  `id` int(11) NOT NULL,
  `addedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `updatedOn` int(10) unsigned NOT NULL DEFAULT 0,
  `nickname` varchar(128) NOT NULL,
  `externalId` int(10) unsigned NOT NULL DEFAULT 0,
  `name` varchar(128) NOT NULL,
  `site` enum('cb','sc','bc','ff','sr','lj','sm') NOT NULL,
  `status` enum('o','a','f','g','p') NOT NULL DEFAULT 'o',
  `statusTime` int(11) unsigned NOT NULL DEFAULT 0,
  `subject` varchar(255) NOT NULL DEFAULT '',
  `age` tinyint(3) unsigned NOT NULL DEFAULT 18,
  `imageUrl` varchar(128) NOT NULL DEFAULT '',
  `lastImageTime` int(10) unsigned NOT NULL DEFAULT 0,
  `numImages` tinyint(3) unsigned NOT NULL DEFAULT 0,
  `viewers` smallint(5) unsigned NOT NULL DEFAULT 0,
  `followers` mediumint(8) unsigned NOT NULL DEFAULT 0,
  `gender` enum('c','f','m','t') NOT NULL DEFAULT 'f',
  `hd` tinyint(1) NOT NULL DEFAULT 0,
  `tags` varchar(2048) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `nickname_site_idx` (`nickname`,`site`),
  KEY `statusTime_site_idx` (`statusTime`,`site`),
  KEY `site_lastImageTime` (`site`,`lastImageTime`),
  KEY `nickname_site_updatedOn_idx` (`nickname`,`site`,`updatedOn`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcamsCategories`
--

DROP TABLE IF EXISTS `webcamsCategories`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webcamsCategories` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(12) NOT NULL,
  `webcamsId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`webcamsId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `webcamsTags`
--

DROP TABLE IF EXISTS `webcamsTags`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `webcamsTags` (
  `keep` tinyint(1) NOT NULL DEFAULT 1,
  `name` varchar(12) NOT NULL,
  `webcamsId` int(10) unsigned NOT NULL,
  KEY `name_idx` (`name`),
  KEY `name_webcamsId_idx` (`name`,`webcamsId`),
  KEY `keep_name_idx` (`keep`,`name`)
) ENGINE=MEMORY DEFAULT CHARSET=utf8mb4;
/*!40101 SET character_set_client = @saved_cs_client */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2021-11-26 21:42:27
