<?php

error_reporting(E_ALL);
ini_set('display_errors', 1);

global $_AVOS;
$dir2 = $_AVOS['config']['site']['webDir'] . 'photosBlog/';

if ($_SERVER["REQUEST_METHOD"] == "POST") {
    $hostname = $_AVOS['config']['mysql']['hostname'];
    $username = $_AVOS['config']['mysql']['username'];
    $password = $_AVOS['config']['mysql']['password'];
    $dbname = $_AVOS['config']['mysql']['database'];


    $connection = mysqli_connect($hostname, $username, $password, $dbname);
    if (!$connection) {
        die("Database connection failed: " . mysqli_connect_error());
    }

    // Get data from the form
    $title = $_POST['title'];
    $category = $_POST['category'];
    $tags = $_POST['tags'];
    $blogkeywords = $_POST['blogkeywords'];
    $description = $_POST['description'];
    $authors = $_POST['authors'];
    $authorssescription = $_POST['authorssescription'];
    $creationDate = date('Y-m-d H:i:s');
    $content = $_POST['content'];
    $modelName = $_POST['modelName'];
    $modelSites = $_POST['modelSites'];
    $contentType = $_POST['contentType'];


 

    // Generate unique file names for uploaded images
    $MainImageFileName = generateUniqueFileName($_FILES['MainImage']['name']);
    $avatarImageFileName = generateUniqueFileName($_FILES['ImagePathAvatar']['name']);
    $GalleryImages = generateUniqueFileName($_FILES['GalleryImages']['name']);

    // Check if the uploaded images are allowed types
    $allowedImageTypes = ['jpg', 'jpeg', 'png'];
    if (
        !in_array(strtolower(pathinfo($MainImageFileName, PATHINFO_EXTENSION)), $allowedImageTypes) ||
        !in_array(strtolower(pathinfo($avatarImageFileName, PATHINFO_EXTENSION)), $allowedImageTypes)
    ) {
        die("Error: Allowed image types are JPG, JPEG, and PNG.");
    }

// Convert the array of converted filenames into a comma-separated string
   // $galleryImagesString = implode(',', $convertedGalleryFilenames);

    // Insert data into the database using parameterized query
 // Insert data into the database using parameterized query
$insertQuery = "INSERT INTO ArticleBlogPosts (Title, Category, Tags, blogkeywords, Description, Authors, CreationDate, Content, ModelName, ModelSites, ContentType, ImagePathAvatar, MainImage, GalleryImages,authorssescription) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
$stmt = mysqli_prepare($connection, $insertQuery);

if (!$stmt) {
    die("Preparation failed: " . mysqli_error($connection));
}

// Update the filenames to their converted versions before binding
$avatarImageFileName = "avatarImage.webp";
$MainImageFileName = "MainImage.webp";


$convertedGalleryFilenames = [];

foreach ($_FILES['GalleryImages']['name'] as $key => $filename) {
    $extension = pathinfo($filename, PATHINFO_EXTENSION);
    $convertedFilename = "photo_" . ($key + 1) . ".webp";
    $convertedGalleryFilenames[] = $convertedFilename;
}

$GalleryImages = implode(',', $convertedGalleryFilenames);   

mysqli_stmt_bind_param($stmt, "sssssssssssssss", $title, $category, $tags, $blogkeywords, $description, $authors, $creationDate, $content, $modelName, $modelSites, $contentType, $avatarImageFileName, $MainImageFileName, $GalleryImages, $authorssescription);


    if (mysqli_stmt_execute($stmt)) {
        $postId = mysqli_insert_id($connection);
        mysqli_stmt_close($stmt);
 
        $postImageDir = $dir2 . $postId . '/';
      //  print_r($postImageDir ); exit;
        if (!file_exists($postImageDir)) {
            mkdir($postImageDir, 0777, true);
        }

        $galleryImageFolder = "GalleryImages" . "/";
        if (!file_exists($postImageDir . $galleryImageFolder)) {
            mkdir($postImageDir . $galleryImageFolder, 0777, true);
        }

        move_uploaded_file($_FILES['MainImage']['tmp_name'], $postImageDir . $MainImageFileName);
        move_uploaded_file($_FILES['ImagePathAvatar']['tmp_name'], $postImageDir . $avatarImageFileName);

      
// Convert Main Image to WebP
$MainImageWebP = $postImageDir . "MainImage.webp";
$extension = strtolower(pathinfo($MainImageFileName, PATHINFO_EXTENSION));

if (in_array($extension, ['jpg', 'jpeg', 'png'])) {
    $imagePath = $postImageDir . $MainImageFileName;

    if (file_exists($imagePath)) {
        try {
            $image = null;

            if ($extension === 'jpg' || $extension === 'jpeg') {
                $image = imagecreatefromjpeg($imagePath);
            } elseif ($extension === 'png') {
                $image = imagecreatefrompng($imagePath);
            }

            if ($image) {
                // Convert image to WebP format
                if (imagewebp($image, $MainImageWebP, 85)) {
                    echo "Main Image converted to WebP successfully<br>";
                    imagedestroy($image);
                    // Remove the original image
                    unlink($imagePath);
                    
                    // Now insert the WebP image filename into the database
                    $MainImageFileName = "MainImage.webp";
                } else {
                    echo "Failed to create WebP image: Main Image<br>";
                }
            } else {
                echo "Failed to create image resource for: Main Image<br>";
            }
        } catch (Exception $e) {
            echo "Error: " . $e->getMessage() . "<br>";
        }
    } else {
        echo "Debug: Image not found at path: $imagePath<br>";
    }
}

// Convert Avatar Image to WebP
$avatarImageWebP = $postImageDir . "avatarImage.webp";
$extension = strtolower(pathinfo($avatarImageFileName, PATHINFO_EXTENSION));

if (in_array($extension, ['jpg', 'jpeg', 'png'])) {
    $imagePath = $postImageDir . $avatarImageFileName;

    if (file_exists($imagePath)) {
        try {
            $image = null;

            if ($extension === 'jpg' || $extension === 'jpeg') {
                $image = imagecreatefromjpeg($imagePath);
            } elseif ($extension === 'png') {
                $image = imagecreatefrompng($imagePath);
            }

            if ($image) {
                // Convert image to WebP format
                if (imagewebp($image, $avatarImageWebP, 85)) {
                    echo "Avatar Image converted to WebP successfully<br>";
                    imagedestroy($image);
                    // Remove the original image
                    unlink($imagePath);
                    
                    // Now insert the WebP image filename into the database
                    $avatarImageFileName = "avatarImage.webp";
                } else {
                    echo "Failed to create WebP image: Avatar Image<br>";
                }
                
            } else {
                echo "Failed to create image resource for: Avatar Image<br>";
            }
        } catch (Exception $e) {
            echo "Error: " . $e->getMessage() . "<br>";
        }
    } else {
        echo "Debug: Image not found at path: $imagePath<br>";
    }
}


//// Convert images in the gallery to WebP format and rename them
$galleryImagesWebP = $postImageDir . "GalleryImages/";
$counter = 1;
$convertedGalleryFilenames = [];

foreach ($_FILES['GalleryImages']['tmp_name'] as $key => $tmpName) {
    $extension = strtolower(pathinfo($_FILES['GalleryImages']['name'][$key], PATHINFO_EXTENSION));
    
    if (in_array($extension, ['jpg', 'jpeg', 'png'])) {
        $imagePath = $tmpName;
        $destinationFileName = "photo_" . $counter . ".webp";
        $destinationPath = $galleryImagesWebP . $destinationFileName;
        
        if (file_exists($imagePath)) {
            try {
                $image = null;
                if ($extension === 'jpg' || $extension === 'jpeg') {
                    $image = imagecreatefromjpeg($imagePath);
                } elseif ($extension === 'png') {
                    $image = imagecreatefrompng($imagePath);
                }
                
                if ($image) {
                    if (!file_exists(dirname($destinationPath))) {
                        mkdir(dirname($destinationPath), 0777, true);
                    }
                    
                    // Convert image to WebP format
                    if (imagewebp($image, $destinationPath, 85)) {
                       // echo "Gallery Image converted and renamed successfully: " . $_FILES['GalleryImages']['name'][$key] . "<br>";
                        imagedestroy($image);

                        // Update the filename in the $_FILES array
                        $_FILES['GalleryImages']['name'][$key] = $destinationFileName;
                        
                        // Add converted filename to the array
                        $convertedGalleryFilenames[] = $destinationFileName;
                    } else {
                        echo "Failed to create WebP image: Gallery Image: " . $_FILES['GalleryImages']['name'][$key] . "<br>";
                    }
                } else {
                    echo "Failed to create image resource for: Gallery Image: " . $_FILES['GalleryImages']['name'][$key] . "<br>";
                }
            } catch (Exception $e) {
                echo "Error: " . $e->getMessage() . "<br>";
            }
        } else {
            echo "Debug: Image not found at path: $imagePath<br>";
        }
        
        $counter++; // Increment the counter for the next image
    }
    $convertedGalleryFilenames[] = $destinationFileName;
    // Update the $GalleryImages variable with the converted filenames

}
$GalleryImages = "GalleryImages/" . implode(',', $convertedGalleryFilenames);
//print_r($GalleryImages);exit;


echo "Post was created successfully!";
header("Location: ?page=blog-list");
exit(); // Important to exit after redirection
} else {
echo "Error inserting data: " . mysqli_stmt_error($stmt);
}
    
}

function generateUniqueFileName($fileName) {
    $uniqueName = uniqid() . "_" . $fileName;
    return $uniqueName;
}

?>


<!-- The rest of your HTML form and script -->




<!--<script src="https://cdn.tiny.cloud/1/<?= $_AVOS['config']['blog']['TinyMCEapi_key']?>/tinymce/5/tinymce.min.js"></script>-->
<!-- TinyMCE initialization script -->
<script src="https://cdn.tiny.cloud/1/no-origin/tinymce/5.10.9-138/tinymce.min.js"></script>
<script>
   document.addEventListener("DOMContentLoaded", function () {
      // Initialize TinyMCE for the description textarea
      tinymce.init({
         selector: "#description",
         height: 300,
         plugins: [
            'advlist autolink lists link image charmap print preview anchor',
            'searchreplace visualblocks code fullscreen',
            'insertdatetime media table paste code help ',
            'emoticons hr pagebreak nonbreaking toc',
            'contextmenu directionality emoticons template textcolor '
         ],
         toolbar: "undo redo | formatselect | bold italic backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | removeformat | link image media",
         menubar: "file edit view insert format tools table help ",
         content_css: [
            "https://cdn.tiny.cloud/1/<?= $_AVOS['config']['blog']['TinyMCEapi_key']?>/tinymce/5/content.css"  // Use your own content CSS
         ],
         setup: function (editor) {
            editor.on('init', function () {
               // Create a function to update character count
               function updateCharCount() {
                  var content = editor.getContent();
                  var count = content.length;
                  var remaining = 250 - count;
                  var charCountElement = document.getElementById('description-char-count');

                  if (charCountElement) {
                     charCountElement.textContent = remaining + " characters remaining";
                     charCountElement.style.color = remaining < 10 ? 'red' : 'green';
                  }
               }

               editor.on('keyup', updateCharCount);
            });
         }
      });

      // Initialize TinyMCE for the content textarea
      tinymce.init({
         selector: "#content",
         height: 300,
         plugins: [
            'advlist autolink lists link image charmap print preview anchor',
            'searchreplace visualblocks code fullscreen',
            'insertdatetime media table paste code help ',
            'emoticons hr pagebreak nonbreaking toc',
            'contextmenu directionality emoticons template textcolor '
         ],
         toolbar: "undo redo | formatselect | bold italic backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | removeformat | link image media",
         menubar: "file edit view insert format tools table help ",
         content_css: [
            "https://cdn.tiny.cloud/1/<?= $_AVOS['config']['blog']['TinyMCEapi_key']?>/tinymce/5/content.css"  // Use your own content CSS
         ],
         setup: function (editor) {
            editor.on('init', function () {
               function updateCharCount() {
                  var content = editor.getContent();
                  var count = content.length;
                  var remaining = 2500 - count;
                  var charCountElement = document.getElementById('content-char-count');

                  if (charCountElement) {
                     charCountElement.textContent = remaining + " characters remaining";
                     charCountElement.style.color = remaining < 10 ? 'red' : 'green';
                  }
               }

               editor.on('keyup', updateCharCount);
            });
         }
      });

      // Initialize TinyMCE for the authorssescription textarea
      tinymce.init({
         selector: "#authorssescription",
         height: 300,
         plugins: [
            'advlist autolink lists link image charmap print preview anchor',
            'searchreplace visualblocks code fullscreen',
            'insertdatetime media table paste code help ',
            'emoticons hr pagebreak nonbreaking toc',
            'contextmenu directionality emoticons template textcolor '
         ],
         toolbar: "undo redo | formatselect | bold italic backcolor | alignleft aligncenter alignright alignjustify | bullist numlist outdent indent | removeformat | link image media",
         menubar: "file edit view insert format tools table help ",
         content_css: [
            "https://cdn.tiny.cloud/1/<?= $_AVOS['config']['blog']['TinyMCEapi_key']?>/tinymce/5/content.css"  // Use your own content CSS
         ],
         setup: function (editor) {
            editor.on('init', function () {
               function updateCharCount() {
                  var content = editor.getContent();
                  var count = content.length;
                  var remaining = 250 - count;
                  var charCountElement = document.getElementById('authorssescription-char-count');

                  if (charCountElement) {
                     charCountElement.textContent = remaining + " characters remaining";
                     charCountElement.style.color = remaining < 10 ? 'red' : 'green';
                  }
               }

               editor.on('keyup', updateCharCount);
            });
         }
      });
   });
</script>








<div class="row">
    <h3 class="title1">Create New Article</h3>
    <p> bug is not deleting the directories from image path</p>
    <div class="form-three widget-shadow">
        <form class="form-horizontal" enctype="multipart/form-data" method="post">
        <div class="form-group">
        <label for="title" class="col-sm-2 control-label">Post Title</label>
        <div class="col-sm-8">
        <input type="text" class="form-control1" id="title" name="title" oninput="updateCharCount(this, 'title-char-count', 255)">

        </div>
        <div class="col-sm-2">
                    <p class="help-block" id="title-char-count">255 characters remaining</p>
                </div>
    </div>

            <div class="form-group">
                <label for="selector1" class="col-sm-2 control-label">Category Select</label>
                <div class="col-sm-8">
                <select name="category" id="category" class="form-control1">
                <option><?= isset($row['Category']) ? $row['Category'] : '' ?></option>
                        <option value="">*******************</option>
                        <option value="Adult dreams">Adult dreams</option>
                        <option value="Erotic dreams">Erotic dreams</option>
                        <option value="Fantasies">Fantasies</option>
                        <option value="Games">Gaming and Virtual Worlds</option>
                        <option value="Interview">Interview</option>
                        <option value="Lifestyle">Lifestyle</option>
                        <option value="Models">Models</option>
                        <option value="Relationships">Relationship Advice</option>
                        <option value="Reviews">Models Show Reviews</option>
                        <option value="Psychology">Psychology</option>
                        <option value="Sexuality">Sexuality</option>
                        <option value="Cam Toys">Cam Toys</option>
                        <option value="Travel">Travel</option>
                        <option value="Videos">Videos</option>
                        <option value="">*******************</option>
                               
                        <option value="Anal Sex">Anal Sex</option>
                        <option value="Artistic Porn">Artistic Porn</option>
                        <option value="ASMR">ASMR</option>
                        <option value="BDSM">BDSM</option>
                        <option value="Big Cock">Big Cock</option>
                        <option value="Big Tits">Big Tits</option>
                        <option value="Blondes">Blondes</option>
                        <option value="Blowjobs">Blowjobs</option>
                        <option value="Brunettes">Brunettes</option>
                        <option value="Cumshot">Cumshot</option>
                        <option value="Couples Fucking">Couples Fucking</option>
                        <option value="Female Masturbation">Female Masturbation</option>
                        <option value="Free Audio Porn">Free Audio Porn</option>
                        <option value="Free Erotic Audio">Free Erotic Audio</option>
                        <option value="Free Erotic Films">Free Erotic Films</option>
                        <option value="Free Erotic Stories">Free Erotic Stories</option>
                        <option value="Free Porn Stories">Free Porn Stories</option>
                        <option value="Group Sex">Group Sex</option>
                        <option value="Hairy Pussy">Hairy Pussy</option>
                        <option value="Hot Naked Guys">Hot Naked Guys</option>
                        <option value="Hotwife Sex">Hotwife Sex</option>
                        <option value="Kinky Sex">Kinky Sex</option>
                        <option value="Kissing">Kissing</option>
                        <option value="Lesbian Porn">Lesbian Porn</option>
                        <option value="Lingerie">Lingerie</option>
                        <option value="Male Masturbation">Male Masturbation</option>
                        <option value="Male Voice">Male Voice</option>
                        <option value="Outdoor Sex">Outdoor Sex</option>
                        <option value="Pussy Licking">Pussy Licking</option>
                        <option value="Redheads">Redheads</option>
                        <option value="Romantic Sex">Romantic Sex</option>
                        <option value="Sex Toys">Sex Toys</option>
                        <option value="Sexual Fantasy">Sexual Fantasy</option>
                        <option value="Shaved Pussy">Shaved Pussy</option>
                        <option value="Small Tits">Small Tits</option>
                        <option value="Soft Porn">Soft Porn</option>
                        <option value="Stranger Sex">Stranger Sex</option>
                        <option value="Threesome Porn">Threesome Porn</option>
                        <option value="Threesome">Threesome</option>
                        <option value="Travel">Travel</option>
                        <option value="Voyeur">Voyeur</option>
                        <option value="Voyeur Sex">Voyeur Sex</option>
                        <option value="Written by Ladies">Written by Ladies</option>
                        <option value="Written by Men">Written by Men</option>
                 
                        
   


                    </select>
                </div>
            </div>

          <div class="form-group">
                <label for="selector1" class="col-sm-2 control-label">Webcams Preformar</label>
                <div class="col-sm-8">
                    <div class="col-xs-12 col-sm-6 ">
                        <div class="col-xs-12">
                            <input type="text" id="modelName" name="modelName" class="form-control1"
                                placeholder="Model Name">
                        </div>
                    </div>
                    <div class=" col-xs-12 col-sm-6">
                        <div class="col-xs-12">
                            <select id="modelSites" name="modelSites" class="form-control1">
                                <option disabled>Select Website</option>
                                <option value="Chaturbate">Chaturbate</option>
                                <option value="StripChat">StripChat</option>
                                <option value="BongaCams">BongaCams</option>
                                <option value="CamSoda">CamSoda</option>
                                <option value="Flirt4Free">Flirt4Free</option>
                                <option value="LiveJasmin">LiveJasmin</option>
                            </select>
                        </div>
                    </div>
                </div>
            </div>

            <div class="form-group">
                <label for="focusedinput" class="col-sm-2 control-label">Tags</label>
                <div class="col-sm-8">
    <input type="text" class="form-control1" id="tags" name="tags" oninput="updateCharCount(this, 'tags-char-count', 255)">
</div>
<div class="col-sm-2">
    <p class="help-block" id="tags-char-count">255 characters remaining</p>
</div>
            </div>

            <div class="form-group">
                <label for="focusedinput" class="col-sm-2 control-label">KeyWords</label>
                <div class="col-sm-8">
    <input type="text" class="form-control1" id="blogkeywords" name="blogkeywords" oninput="updateCharCount(this, 'blogkeywords-char-count', 255)">
</div>
<div class="col-sm-2">
    <p class="help-block" id="blogkeywords-char-count">255 characters remaining</p>
</div>
            </div>




            <div class="form-group">
    <label for="checkbox" class="col-sm-2 control-label">Post Content</label>
    <div class="col-sm-8">
        <div class="checkbox-inline"><label><input type="checkbox" id="contentType-adult" name="contentType" value="adult" checked> Adult</label></div>
        <div class="checkbox-inline"><label><input type="checkbox" id="contentType-non" name="contentType" value="nonadult"> NonAdult</label></div>
    </div>
</div>

            <div class="form-group">
   <label for="txtarea1" class="col-sm-2 control-label">Short Description *</label>
   <div class="col-sm-8">
    <textarea id="description" name="description" cols="150" rows="9" class="form-control1" aria-hidden="true"></textarea>
</div>
<div class="col-sm-2">
    <p class="help-block" id="description-char-count">250 characters remaining</p>
</div>

</div>

<div class="form-group">
   <label for="content" class="col-sm-2 control-label">Article Content</label>
   <div class="col-sm-8">
      <textarea id="content" name="content" contenteditable="true" class="form-control1"></textarea>
   </div>
   <div class="col-sm-2">
    <p class="help-block" id="content-char-count">2500 characters remaining</p>
</div>

</div>
            <div class="form-group">
                <label for="smallinput" class="col-sm-2 control-label label-input-sm">Authors</label>
                <div class="col-sm-8">
                    <input type="text" class="form-control1 input-sm" id="authors" name="authors">
                </div>
            </div>

            <div class="form-group">
   <label for="txtarea1" class="col-sm-2 control-label">Short Authors Description</label>
   <div class="col-sm-8">
      <textarea id="authorssescription" name="authorssescription" cols="10" rows="1" class="form-control1" aria-hidden="true"></textarea>
   </div>
   <div class="col-sm-2">
    <p class="help-block" id="authorssescription-char-count">250 characters remaining</p>
</div>
</div>

            <div class="form-group">
                <label for="smallinput" class="col-sm-2 control-label label-input-sm">Creation Date:</label>
                <div class="col-sm-8">
                    <input type="date" class="form-control1 input-sm" id="date" name="date">
                </div>
            </div>

            <div class="form-group">
        <label for="ImagePathAvatar" class="col-sm-2 control-label">Avatar</label>
        <div class="col-sm-8">
        <input type="file" id="ImagePathAvatar" name="ImagePathAvatar" class="form-control1" accept=".jpg, .jpeg, .png">
            <p class="help-block">Avatar image.</p>
        </div>
        <div class="col-sm-2">
    <p class="help-block">250px x 250px (accept=".jpg, .jpeg, .png")</p>
</div>
    </div>

    <div class="form-group">
        <label for="MainImage" class="col-sm-2 control-label">Main Image</label>
        <div class="col-sm-8">
        <input type="file" id="MainImage" name="MainImage" class="form-control1" accept=".jpg, .jpeg, .png">
            <p class="help-block">Main image</p>
        </div>
        <div class="col-sm-2">
    <p class="help-block"> 900px max  (accept=".jpg, .jpeg, .png")</p>
</div>
    </div>

    <div class="form-group">
        <label for="GalleryImages" class="col-sm-2 control-label">Gallery Images</label>
        <div class="col-sm-8">
        <input type="file" id="GalleryImages" name="GalleryImages[]" multiple class="form-control1" accept=".jpg, .jpeg, .png">
            <p class="help-block">Gallery Images.</p>
        </div>
        <div class="col-sm-2">
    <p class="help-block">900px max (accept=".jpg, .jpeg, .png")</p>
</div>
    </div>

    <div class="form-group">
        <div class="col-sm-offset-2 col-sm-8">
            <button type="submit" class="btn btn-primary">Publish</button>
        </div>
    </div>
        </form>



    </div>
</div>

<!-- Add this JavaScript code within the <script> tag in your HTML file -->
<script>
  function updateCharCount(input, charCountId, maxChars) {
    var charCountElement = document.getElementById(charCountId);
    var remainingChars = maxChars - input.value.length;
    
    charCountElement.textContent = remainingChars + " characters remaining";

    // Change color based on the remaining characters
    charCountElement.style.color = remainingChars < 10 ? 'red' : 'green';
  }
</script>
