
    <title><?= $sitename ?> - Privacy Policy</title>
    <style>
        body {
            font-family: Arial, sans-serif;
            margin: 0;
            padding: 0;
            background-color: #f4f4f4;
            color: #333;
        }
        .content {
            max-width: 900px;
            margin: 20px auto;
            padding: 20px;
            background: #fff;
            border-radius: 8px;
            box-shadow: 0 0 10px rgba(0, 0, 0, 0.1);
        }
        .top-placement {
            text-align: center;
            margin-bottom: 20px;
        }
        .placement-wrapper {
            display: inline-block;
            background: #007bff;
            color: #fff;
            padding: 10px 20px;
            border-radius: 4px;
            font-size: 18px;
        }
        .page-content {
            background: #fff;
            padding: 20px;
        }
      
        p {
            font-size: 16px;
            line-height: 1.6;
            margin-bottom: 1em;
        }
        a {
            color: #007bff;
            text-decoration: none;
        }
        a:hover {
            text-decoration: underline;
        }
        .contact-button {
            display: inline-block;
            background-color: #007bff;
            color: #fff;
            padding: 10px 20px;
            border-radius: 4px;
            text-decoration: none;
            font-weight: bold;
            margin-top: 20px;
        }
        .contact-button:hover {
            background-color: #0056b3;
        }
        .important-info {
            background-color: #f1f1f1;
            padding: 10px;
            border-left: 5px solid #007bff;
            margin-bottom: 20px;
        }
    </style>

    <div class="content">
        <div class="top-placement">
            <div class="tabsItems">Privacy Policy</div>
        </div>
        <div class="page-content">
            <h1>Privacy Policy</h1>
            <h2>Your privacy is very important to us.</h2>

            <p>We have created this privacy policy (the "Policy") to demonstrate our commitment to your privacy. This Policy explains what information we collect about you and how we use it. We encourage you to read this Policy in conjunction with our Terms of Use, available at <a href="https://<?=lcfirst($sitename)?>/terms-conditions"><?=$sitename?>/terms-conditions</a>.</p>

            <h2>Information We Collect</h2>
            <p>We collect the following types of information:</p>
            <ul>
                <li><strong>Personal Information:</strong> Includes your name, email address, telephone number, and credit card information. This information is collected when you register on our site, make a purchase, or otherwise interact with us.</li>
                <li><strong>Technical Data:</strong> Includes IP addresses, screen resolution, browser language, and device information.</li>
                <li><strong>Usage Data:</strong> Includes the date and time of your visit, pages visited, and the site from which you came.</li>
            </ul>

            <h2>How We Use Your Information</h2>
            <p>We use the information we collect to:</p>
            <ul>
                <li>Provide and improve our services.</li>
                <li>Process transactions and fulfill orders.</li>
                <li>Communicate with you about your account and respond to inquiries.</li>
                <li>Prevent fraudulent transactions and enforce our terms.</li>
                <li>Analyze site usage and improve user experience.</li>
            </ul>

            <h2>Data Sharing and Third Parties</h2>
            <p>We may share your information with:</p>
            <ul>
                <li><strong>Service Providers:</strong> Third parties that assist in operating our website and conducting business.</li>
                <li><strong>Legal Requirements:</strong> When required by law or to protect our rights and safety.</li>
            </ul>

            <h2>Security of Your Information</h2>
            <p>We use reasonable measures to protect your personal information from unauthorized access or disclosure. However, no method of transmission over the Internet is 100% secure, and we cannot guarantee absolute security.</p>

            <h2>Your Rights</h2>
            <p>Depending on your location, you may have the following rights:</p>
            <ul>
                <li><strong>Access:</strong> Request a copy of the personal information we hold about you.</li>
                <li><strong>Correction:</strong> Request correction of inaccurate or incomplete information.</li>
                <li><strong>Deletion:</strong> Request deletion of your personal information.</li>
                <li><strong>Opt-Out:</strong> Opt-out of certain uses of your information, such as marketing communications.</li>
            </ul>

            <h2>Cookies and Tracking Technologies</h2>
            <p>We use cookies to enhance your experience on our website. You can manage your cookie preferences through your browser settings. Please note that disabling cookies may affect the functionality of the website.</p>

            <h2>Links to Other Websites</h2>
            <p>Our website may contain links to third-party websites. We are not responsible for the privacy practices of these sites. We encourage you to review the privacy policies of any third-party sites you visit.</p>

            <h2>Changes to This Policy</h2>
            <p>We may update this Policy from time to time. Any changes will be posted on this page with an updated effective date. We encourage you to review this Policy periodically for any updates.</p>

            <h2>Contact Us</h2>
            <p>If you have any questions about this Policy or wish to exercise your rights, please contact our Data Protection Officer (DPO) using the "Contact Us" button below:</p>
            </p>
            <?php if (isset($promoteEmail) && !empty($promoteEmail)): ?>
    <a href="mailto:<?= htmlspecialchars($promoteEmail, ENT_QUOTES, 'UTF-8') ?>">Contact Us</a> &bull;
<?php endif; ?>
        </div>
    </div>

