<?php
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);
?>
  <style>
.letTopthis {
    /* Custom styles for 'letTopthis' class */
}

.letTopthis::after {
    content: "<?= $modelsSidebarIcon ?>";
    font-family: 'FontAwesome';
    font-size: 21px;
    position: absolute;
    left: -1px;
    color: <?= $colorSidebarIcon ?>;
    border-radius: 20px;
    top: 30px;
}

/* colors */
.feed-v2 #scroll-container .timeline-entry {
    border-radius: 13px;
    background-color: <?= $navbarBGColor?>;
}

.feed-v2 #scroll-container .timeline-entry .timeline-entry-footer {
height: 50px;
}

.feed-v2 #scroll-container .timeline-entry .timeline-entry-header a:not(.btn) {
    color: <?=$menuLinkColor?>;
}

.text-color {
    color: <?=$menuLinkColor?>;
}

.modal-header, .text-color, .text-color:hover {
    color: <?=$menuLinkColor?>;
}

/* colors */

/* Story circles styling */
#timeline-storybar .story-circles .story-circle {
    position: relative;
    display: flex;
    flex-direction: inherit;
    padding: 2px 5px;
    align-items: center;
    border-radius: 3px;
    color: var(--black-700);
    width: 100%;
}

#timeline-storybar {
    order: 2;
    flex-shrink: 1;
    flex-grow: 1;
    min-width: 80px;
}

#timeline-storybar .story-circles {
    background-color: transparent;
    border-radius: 3px;
    border: none;
    margin: 10px 0 0 6px;
    padding: 4px 0;
    flex-direction: column;
    width: 60px;
}

.feed-v2 {
    max-width: 90%;
    margin: 0 auto;
}

#timeline-storybar {
    position: fixed;
    right: 0;
    top: 79px;
    height: 100%;
    overflow-y: auto;
    background: transparent;
    padding: 10px;
}

#scroll-outer-container {
    display: flex;
    justify-content: center;
}

#scroll-container {
    max-width: 800px;
    width: 100%;
}

.title-model {
    font-size: 12px;
    display: block;
    text-align: center;
    font-weight: 800;
}

.small-size{
    font-size: 10px;
    display: block;
    text-align: center;
    font-weight: 800;
    color:<?=$menuLinkColor?>;
}

/* Responsive styling */
@media (max-width: 1200px) {
    #timeline-storybar {
        position: static;
        width: 100%;
        top: 0;
        height: auto;
        overflow-y: visible;
        display: flex;
        justify-content: center;
    }

    .story-circles {
        flex-direction: row;
        width: auto;
    }

    .story-circle {
        flex-direction: column;
    }
}

@media (max-width: 768px) {
    #scroll-container {
        max-width: 100%;
        padding: 0 10px;
    }
}

@media (max-width: 576px) {
    .feed-v2 {
        max-width: 100%;
    }

    #timeline-storybar {
        display: none;
    }
}




.profile-link {

    display: block;
    width: 100%;
    height: 0;
    padding-top: 56.25%; /* Aspect ratio 16:9 */
    overflow: hidden;
}

.profile-link playah {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    border: none;
}

.overlay {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    background-color: transparent;
    cursor: pointer;
    z-index: 1;
    pointer-events: all; /* Enable pointer events to capture clicks */
}

.see-more-button {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
    padding: 10px 20px;
    background-color: rgba(0, 0, 0, 0.7);
    color: white;
    border: none;
    border-radius: 5px;
    cursor: pointer;
    font-size: 16px;
    text-align: center;
    z-index: 2; /* Ensure button is above overlay */
}

.see-more-button:hover {
    background-color: rgba(0, 0, 0, 0.9);
}
</style>

<? if ($page == 1 && isset($pages)): ?>
<div id='num-pages' data-pages='<?= $pages ?>'></div>
<!-- <?= $matches ?> models, <?= $pages ?> pages -->
<? endif; ?>

<? if (!isset($_GET['layout']) || $url['page'] == 1 || $page == 1): ?>

<? if ($url['name'] == 'home' && $webcamsSearchCloud) include('webcamsSearchCloud.php'); ?>

<? if (($titleVisible && !empty($title)) || $gridSizeSelectors): ?>
    <div class="page-head">
        <div class="page-title">
<? endif; ?>

<? if ($titleVisible && !empty($title)): ?><h1><?= $title ?></h1><? endif; ?>
<? include('gridSizeSelectors.php'); ?>

<? if (($titleVisible && !empty($title)) || $gridSizeSelectors): ?>
        </div>
    </div>
<? endif; ?>

<? endif; ?>

<? //print_r($models[0]) ?>

<div id="content-yield-container">
    <div class="alert-container row"></div>

    <div class="feed-v2" id="timeline-feed">
        <div id="timeline-content">
            <div id="timeline-storybar" class="hidden-xs">
                <div class="story-circles">

                <?php
                // Check if it's the initial load or a subsequent AJAX request
                $isInitialLoad = (!isset($_GET['page']) || $_GET['page'] == 1);

                // Combine sideRightBar and models
                $combinedModels = array_merge($sideRightBar, $models);

                // Remove duplicates from $models that are already in $sideRightBar
                $combinedModelsUnique = [];
                foreach ($combinedModels as $m) {
                    $key = $m['site'] . ':' . $m['nickname'];
                    if (!isset($combinedModelsUnique[$key])) {
                        $combinedModelsUnique[$key] = $m;
                    }
                }

                // Reset array keys to start from 0
                $combinedModelsUnique = array_values($combinedModelsUnique);

                // Count of featured models to be displayed
                $sideRightBarCount = count($sideRightBar);

                // Display up to 30 models
                $modelCount = min(30, count($combinedModelsUnique));
                ?>

                <!-- Display up to 30 models -->
                <div class="models-block">
                    <?php
                    // Only render models if it's the initial load or no models have been rendered yet
                    if ($isInitialLoad): 
                        for ($i = 0; $i < $modelCount; $i++):
                            $m = $combinedModelsUnique[$i];
                    ?>
                            <a class="story-circle <?= in_array($m, $sideRightBar) ? 'letTopthis' : '' ?>" data-story="storyline: <?= htmlspecialchars($m['nickname']) ?>" data-story-autoshow-next="true" href="<?= htmlspecialchars(strtolower(encodeUrl('webcamsProfile' . ($webcamsProfilePerSite == 1 ? $m['siteShortNameCaps'] : ''), $m))) ?>">
                                <span class="story-circle-sp1">
                                    <span class="story-circle-sp2">
                                        <span class="story-circle-sp3">
                                            <img src="<?= htmlspecialchars($m['imageUrl']) ?>" class="thumb carousel-item active no-margin-shift" alt="<?= htmlspecialchars($m['nickname']) ?> from <?= htmlspecialchars($m['site']) ?>">
                                        </span>
                                    </span>
                                </span>
                            </a>
                    <?php
                        endfor;
                    endif;
                    ?>
                </div>

                </div>
            </div>

            <div id="scroll-outer-container">
                <div id="scroll-container" class="avatar-status-managed">
                    <?php
                    // Combine $sideRightBar and $models
                    $combinedModels = array_merge($sideRightBar, $models);

                    // Remove duplicates based on 'site' and 'nickname'
                    $uniqueModels = [];
                    foreach ($combinedModels as $m) {
                        $key = $m['site'] . ':' . $m['nickname'];
                        if (!isset($uniqueModels[$key])) {
                            $uniqueModels[$key] = $m;
                        }
                    }

                    // Reset array keys to start from 0
                    $uniqueModels = array_values($uniqueModels);

                    $statusMap = [
                        'Freechat' => 'Online',
                        'Private' => 'Private',
                        'Group' => 'Group',
                        'Away' => 'Away',
                    ];

                    // Display each unique model
                    foreach ($uniqueModels as $m):

                        if (isset($statusMap[$m['status']])) {
                            $m['status'] = $statusMap[$m['status']];
                        } else {
                            $m['status'] = '';
                        }
                    ?>

                    <div id="timeline-entry-<?= htmlspecialchars($m['nickname']) ?>" class="mb10 mt5 timeline-entry thing-data" data-controller="timeline-entry" data-user="<?= htmlspecialchars($m['nickname']) ?>" data-thing-slug="<?= htmlspecialchars($m['nickname']) ?>">
                        <div class="timeline-entry-header">
                            <div class="mr5">
                                <a class="avatar" href="<?= htmlspecialchars(strtolower(encodeUrl('webcamsProfile' . ($webcamsProfilePerSite == 1 ? $m['siteShortNameCaps'] : ''), $m))) ?>">
                                    <span class="avatar-status-container online" data-nick="<?= htmlspecialchars($m['nickname']) ?>">
                                        <img width="400" height="400" loading="lazy" src="<?= htmlspecialchars($m['imageUrl']) ?>" alt="<?= htmlspecialchars($m['nickname']) ?> from <?= htmlspecialchars($m['site']) ?> is in <?= htmlspecialchars($m['status']) ?>">
                                    </span>
                                </a>
                            </div>
                            <div class="flex-grow" style="padding-top:2px;">
                                <div class="flex-row space-between center">
                                    <div class="flex-col flex flex-center">
                                        <span class="bold user-link">
                                            <a class="feed" href="<?= htmlspecialchars(strtolower(encodeUrl('webcamsProfile' . ($webcamsProfilePerSite == 1 ? $m['siteShortNameCaps'] : ''), $m))) ?>"><?= htmlspecialchars($m['nickname']) ?></a>
                                        </span>
                                        <span class="ml10 follow-buttons pull-right text-color" data-synced-interests-target="followButton" data-id="36707593">
                                            <span class="hidden-xs"><?= htmlspecialchars($m['site']) ?></span>
                                        </span>
                                    </div>
                                    <div class="flex-col-no-grow text-light mr10">
                                        <a href="<?= htmlspecialchars(strtolower(encodeUrl('webcamsProfile' . ($webcamsProfilePerSite == 1 ? $m['siteShortNameCaps'] : ''), $m))) ?>">
                                            <span class="noun timelinepost">Last Broadcast • </span>
                                            <span class="time-ago" data-keep-updated="true" data-format="short" style="opacity: 1;">
                                                <?php if ($m['statusTime'] < 60): ?>
                                                    <?= htmlspecialchars($m['statusTime']) ?>m
                                                <?php else: ?>
                                                    <?= htmlspecialchars(sprintf('%0.1f', $m['statusTime'] / 60)) ?>h
                                                <?php endif; ?>
                                            </span>
                                        </a>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="timeline-entry-body thing-type-timelinepost">
                            <div class="timeline-post-description text-color">
                                <?php if (empty($m['subject'])): ?>
                                    <?= htmlspecialchars($m['location']) ?>
                                <?php else: ?>
                                    <?= htmlspecialchars(truncate($m['subject'], 45)) ?>
                                <?php endif; ?>
                                <small>
                                    <?php if (isset($m['title']) && !empty($m['title'])): ?>
                                        <span class="title-model">
                                            <?= htmlspecialchars($m['title']) ?>
                                        </span>
                                    <?php endif; ?>
                                </small>
                            </div>
                            <div id="timeline-playah-container-<?= htmlspecialchars($m['nickname']) ?>" class="timeline-entry-playah-container">
                                <div style="position:relative; width:100%; padding-top:168.42105263157893%"></div>
       
       
                                <a href="<?= htmlspecialchars(strtolower(encodeUrl('webcamsProfile' . ($webcamsProfilePerSite == 1 ? $m['siteShortNameCaps'] : ''), $m))) ?>" title="<?= htmlspecialchars($m['nickname']) ?> from <?= htmlspecialchars($m['site']) ?>" data-nickname="<?= htmlspecialchars($m['nickname']) ?>" data-site="<?= htmlspecialchars($m['site']) ?>" class="profile-link">
    <playah id="playah-<?= htmlspecialchars($m['nickname']) ?>-from-<?= htmlspecialchars($m['site']) ?>" class="rwd-media" title="<?= htmlspecialchars($m['nickname']) ?> from <?= htmlspecialchars($m['site']) ?>" alt="<?= htmlspecialchars($m['nickname']) ?> live on <?= htmlspecialchars($m['site']) ?>" data-nickname="<?= htmlspecialchars($m['nickname']) ?>" data-site="<?= htmlspecialchars($m['site']) ?>">
        <?= Avos\User\encodeChatEmbed(['site' => $m['site'], 'nickname' => $m['nickname']]) ?>
    </playah>
    <div class="overlay"></div>
    <div class="see-more-button"><?=  ucfirst($m['nickname'])?>
<small style="display: flow;">Live Show on <?=  ucfirst($m['site'])?></small>

</div>
</a>
       
                            </div>
                        </div>
                        <div class="timeline-entry-footer" data-timeline-footer="">
                            <div class="flex-row space-between center timeline-action-buttons">
                                <div class="flex-col flex flex-center text-color">
                                    <span class="status <?= strtolower($m['status']) ?>">
                                        <?= htmlspecialchars($m['status']) ?>
                                    </span>
                                </div>
                                <div class="flex-col-no-grow">
                                    <div class="text-color">
                                        <?= htmlspecialchars($m['gender']) ?>
                                        <?= htmlspecialchars($m['age']) ?>
                                    </div>
                                </div>
                                
                            </div>
                            <?php if (isset($m['alttitle']) && !empty($m['alttitle'])): ?>
                                        <small class="small-size text-color">
                                            <?= htmlspecialchars($m['alttitle']) ?>
                                        </small>
                                    <?php endif; ?>
                        </div>
                    </div>
                    <?php endforeach; ?>
                </div>
            </div>
        </div>
    </div>
</div>



<script>
document.addEventListener('DOMContentLoaded', (event) => {
    // Get all profile-link elements
    const profileLinks = document.querySelectorAll('.profile-link');

    profileLinks.forEach(link => {
        // Add click event to handle the entire area as a link
        link.addEventListener('click', (event) => {
            // Only navigate if the "See More" button is clicked
            if (event.target.classList.contains('see-more-button') || event.target.classList.contains('overlay')) {
                event.preventDefault();
                window.location.href = link.href;
            }
        });
    });
});
</script>



<? if (!isset($_GET['layout']) || $url['page'] == 1 || $page == 1): ?>
</div>
<? endif; ?>

<!-- in ajax mode only display loadmore button for page 1 -->
<? if (!empty($paginationLoadMore) && $pages > 1 && $page == 1): ?>
    <div class="item-more" id="loadmore">
        <a href="javascript:page.loadMore();" class="btn btn-theme"><?= $paginationMoreBtnText ?></a>
    </div>
<? endif; ?>

<!-- else display back+next buttons -->
<? if (empty($paginationLoadMore)): ?>
    <div class="item-more" id="loadmore">
        <? if ($page > 1): ?>
            <a href="javascript:document.location=page.getPrevPage();" class="btn btn-theme"><?= $paginationBackBtnText ?></a>
        <? endif; ?>
        <? if ($page < $pages): ?>
            <a href="javascript:document.location=page.getNextPage();" class="btn btn-theme"><?= $paginationNextBtnText ?></a>
        <? endif; ?>
    </div>
<? endif; ?>

<? if (!isset($_GET['layout']) || $url['page'] == 1): ?>
<? endif; ?>
