<?php if (!empty($headerMenuItemsMobile)): ?>
<div id="mobile-menu">
    <div class="root">
        <?php foreach ($headerMenuItemsMobile as $item): ?>
            <?php if ($item['type'] == 'image'): ?>
                <img class="imagemenufooter" width="22" height="22" src="<?= htmlspecialchars($item['label'], ENT_QUOTES, 'UTF-8') ?>">
            <?php elseif ($item['type'] == 'label'): ?>
                <span><?= $item['label'] ?></span>
            <?php else: ?>
                <a href="<?= htmlspecialchars($item['link'], ENT_QUOTES, 'UTF-8') ?>">
                    <span><?= $item['label'] ?></span>
                </a>
            <?php endif; ?>
        <?php endforeach; ?>
    </div>
    <div class="loading-indicator no-transition"></div>
</div>
<?php endif; ?>

<style>




@media (max-width: 768px) {
  #mobile-menu a {
        max-width: 100% !important;
        padding: 0px !important;
        top: 0px;
        right: 1px;
        width: calc(100% - 6px);
        margin: 5px 3px;
        text-align: center;
        border-radius: 6px;
        background-color: <?= $navbarBGColor ?> !important;
        color:<?= $menuLinkColor; ?> !important;
        text-decoration: none;
        box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
        transition: transform 0.3s ease, box-shadow 0.3s ease;
    }
}

.imagemenufooter {
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: center;
    position: inherit;
    overflow: hidden;
    transform: translateZ(0);
    right: -5%;
}




.menuImageClass {
  
    display: block;
 
}

@media (max-width: 768px) {
    #mobile-menu a i {
        font-size: 16px;
        color:<?= $menuIconColor; ?> !important;
    }
}

</style>
