<?
namespace Avos\User;

require_once(SITETEMPLATES . 'Mobile_Detect.php');

function encodeChatEmbed($model, $srcOnly = 0)
{
    $html = \encodeChatEmbed($model, $srcOnly);

    if (getTemplateValue('isMobile')) {
        return preg_replace('!track=(.*?)&!', 'track=$1-mobile&', $html);
    }
    else {
        return $html;
    }
}

function encodeRoomLink($site, $nickname='')
{
    $html = \encodeRoomLink($site, $nickname);

    if (getTemplateValue('isMobile')) {
        return preg_replace('!track=(.*?)&!', 'track=$1-mobile&', $html);
    }
    else {
        return $html;
    }
}

//
// functions loaded for every page
//

function layout()
{
    global $_AVOS;

    \Avos\Utils\profFlag("layout()");

    $webDir = rtrim(getConfig('site')['webDir'], '/');
    $vals = getTemplateValues();

    setTemplateValue('sitename', ucfirst(str_replace(['https://', 'www.', '/'], '', getConfig('site', 'url', 'avos'))));

    if (!empty($vals['mobileTracking'])) {
        $detect = new \Mobile_Detect;
        setTemplateValue('isMobile', $detect->isMobile());
    }
    else {
        setTemplateValue('isMobile', '');
    }

    if (file_exists($webDir . 'preview.png')) {
        $size = getimagesize($webDir . 'preview.png');
        setTemplateValue('previewImg', rtrim(getConfig('site')['url'], '/') . 'preview.png');
        setTemplateValue('previewImgWidth', $size[0]);
        setTemplateValue('previewImgHeight', $size[1]);
    }

    \Avos\Utils\profFlag("getWebcamsCounts()");
	$counts = getWebcamsCounts();

    \Avos\Utils\profFlag("set cats/tags/sites");
	setTemplateValue('counts', $counts);
	setTemplateValue('cats', $counts['categories']);
	setTemplateValue('tags', $counts['tags']);
    setTemplateValue('sites', $counts['sites']);

    if (isset($counts['catstags'])) setTemplateValue('catstags', $counts['catstags']);

    $url = getUrlMatched();
    setTemplateValue('url', $url);

    $sortCategories = $vals['sortCategories'];
    $sortTags = $vals['sortTags'];

    // sort tags for the sidebar if needed

    if (!empty($sortTags)) {
        if (!empty(getUrl('webcamsCategoryTag')) && !empty($url['args']['category']) && isset($counts['catstags'][$url['args']['category']])) {
            \Avos\Utils\profFlag("sorting tags");
            $c = array_column($counts['catstags'][$url['args']['category']], $sortTags);
            array_multisort($c, SORT_DESC, $counts['catstags'][$url['args']['category']]);
            setTemplateValue('catstags', $counts['catstags']);
        }
        else {
            $c = array_column($counts['tags'], $sortTags);
            array_multisort($c, SORT_DESC, $counts['tags']);
            setTemplateValue('tags', $counts['tags']);
        }
    }

    // save/reset selected webcams category

    if ($_SERVER['REDIRECT_URL'] == '/') {
        $_SESSION['category'] = '';
    }
    elseif ($url['name'] == 'webcamsCategory') {
        $_SESSION['category'] = $url['args']['category'];
    }

    // build url for sorting

    $searchUrl = encodeUrl('search') . '?';
    setTemplateValue('searchUrl', $searchUrl);

    /*
    $sortUrl = $_SERVER['REDIRECT_URL'];
    $sortUrl .= '&sort=';

    if (empty($sortUrl) || $sortUrl == '/' ) {
        $sortUrl = $searchUrl;
    }
    else {
        $sortUrl .= '?';
    }

    $sortUrl = $searchUrl;

    if (!empty($_GET['q'])) {
        $sortUrl .= "q=" . $_GET['q'];
    }

    if (!empty($_SESSION['category'])) {
        $sortUrl .= "&category=" . $_SESSION['category'];
    }

    $sortUrl .= '&sort=';
    */

    \Avos\Utils\profFlag('webcamsSearches()');

    if ($url['name'] == 'webcamsCategory' || $url['name'] == 'webcamsTag' || $url['name'] == 'webcamsCategoryTag') {
        $sortUrl = encodeUrl($url['name'], $url['args']) . '?';
    }
    else {
        $sortUrl = $searchUrl;
    }

    $qs = $_GET;
    unset($qs['sort']);
    $qs = \Avos\Utils\array2url($qs);
    $sortUrl .= $qs;
    $sortUrl .= '&sort=';
    setTemplateValue('sortUrl', $sortUrl);

    // fetch the search cloud
    webcamsSearches();

    \Avos\Utils\profFlag('getFeaturedModels()');
    $featured = getFeaturedModels();
    setTemplateValue('embedFeaturedModels', getFeaturedModels('embedFeaturedModels'));

    // save page info from the real webcams etc search
    #$page = $_AVOS['page'];

    //
    // see if we previously viewed an online model and is online
    //

    \Avos\Utils\profFlag('set floatingChatModel');

    if (!empty($_SESSION['floatingChatModel']) && $_SESSION['floatingChatModel'] != -1) {
        $models = getWebcam(['site' => $_SESSION['floatingChatModel']['site'], 'nickname' => $_SESSION['floatingChatModel']['nickname']]);
        if (count($models) == 0 || $models[0]['status'] == 'Offline') {
            unset($_SESSION['floatingChatModel']);
        }
    }

    if (empty($_SESSION['floatingChatModel'])) {
        $model = [];

        if (count($featured) > 0) {
            shuffle($featured);
            $model = $featured[0];
        }

        /*
        if (!empty($vals['floatingEmbedWebcamsModel'])) {

            foreach (explode(',', $vals['floatingEmbedWebcamsModel']) as $m) {

                if (count($model) == 0) {
                    if (preg_match('!^(\w\w):(.*)$!', $m, $c)) {
                        $chk = getWebcams([ 'status' => '!o', 'site' => $c[1], 'nickname' => $c[2] ]);
                        if (count($chk)) {
                            $model = $chk[0];
                        }
                    }
                }
            }
        }
         */

        if (!isset($vals['webcamsFloatingChatDefault'])) {
            $vals['webcamsFloatingChatDefault'] = 1;
        }

        if (count($model) == 0 && $vals['webcamsFloatingChatDefault']) {

            if (!empty($vals['webcamsFloatingChatDefaultFilter'])) {
                $models = getWebcams($vals['webcamsFloatingChatDefaultFilter'] . '&count=1');
            }
            else {
                #$models =  $counts[$vals['floatingEmbedWebcamsCategoryType']][$vals['floatingEmbedWebcamsCategory']]['models'];
                $models =  reset($counts['categories'])['models'];
            }

            if (count($models) > 0) {
                $model = $models[0];
            }
        }

        $_SESSION['floatingChatModel'] = $model;
    }


    // finally set the model to display in the floating embed
    if ($_SESSION['floatingChatModel'] != -1) {
        setTemplateValue('floatingChatModel', $_SESSION['floatingChatModel']);
    }

    // restore page info from the real webcams etc search
    #$_AVOS['page'] = $page;

    // a mixup of models status to use in a sidebar
    /*
    $sidebarModels = getWebcams('site=cb&status=p&count=3');
    $sidebarModels = array_merge($sidebarModels, getWebcams('site=cb&status=g&count=1'));
    $sidebarModels = array_merge($sidebarModels, getWebcams('site=cb&status=f&count=7'));
    shuffle($sidebarModels);
    setTemplateValue('sidebarModels', $sidebarModels);
    */

/*
    //
    // add in the profile titles for models to use in the grid
    //

    $models = getTemplateValue('models');

    if (is_array($models)) {
        foreach ($models as $i => $m) {
            $models[$i]['title'] = \Avos\Scaffold\author('profile:title', $m, 1, $m['id']);
        }

        setTemplateValue('models', $models);
        #echo "<pre>";print_r($models);exit;
    }

    //
    // need to embed the page title, description and keywords within the page
    //

    $words = \Avos\Utils\removeStopWords(getTemplateValue('title'));
    $words .= ' ,' . \Avos\Utils\removeStopWords(getTemplateValue('description'));
    $words .= ' ,' . \Avos\Utils\removeStopWords(getTemplateValue('keywords'));

    setTemplateValue('meta', explode(',', $words));
    setTemplateValue('metaCount', count(getTemplateValue('meta')));
    setTemplateValue('metaIndex', 0);
*/

    setWebcamsMeta();

    //
    // set any page options
    //

    if (!empty($vals[$url['name'] . 'Options'])) {
        foreach (explode(',', $vals[$url['name'] . 'Options']) as $opt) {
            if (preg_match('!(\w+)=(.*)$!', $opt, $c)) {
                setTemplateValue($c[1], $c[2]);
            }
        }
    }

    //
    // save the cat or tag to search cloud
    //

    foreach (['category', 'tag'] as $c) {
        $keyword = getTemplateValue($c);

        if (!empty($keyword)) {
            saveSearch($keyword);
        }
    }

    //
    // selected items to put in the header menu or sidebar
    //

    \Avos\Utils\profFlag('process menu items');

    if (empty($sortCategories)) {
        $catsSorted = $counts['categories'];
    }
    else {
        $catsSorted = getCategories($sortCategories);
    }

    $redis = \Avos\Redis\handle();
    $cache = $redis->get(\Avos\Redis\getPrefix('menuItems'));

    if (!empty($cache)) {
        foreach ($cache as $k => $v) {
            setTemplateValue($k, $v);
        }
    }
    else {
    foreach (['headerMenuItems', 'sidebarMenuItems', 'headerMenuItemsMobile', 'sidebarMenuItemsMobile', 'headerMenuTabsItems', 'headerMenuTabsItemsMobile'] as $varname) {

        \Avos\Utils\profFlag("set $varname");
        $links = [];
        $items = $vals[$varname];

        if (is_array($items)) {
            // layout() has been called a 2nd time
            continue;
        }

        foreach (explode(',', $items) as $item) {

            if (empty($item)) {
                continue;
            }

            #\Avos\Utils\profFlag("set $varname/$item");

            //
            // see if item(s) or a dropdown
            //

            $dropdown = 0;

            if (preg_match('!(.*)Dropdown!', $item, $c)) {
                $dropdown = 1;
                $item = $c[1];

                $tkey = 'menu' . ucfirst($item) . 'Label';
                $menu = ['type' => $item, 'dropdown' => 1, 'items' => []];
                $menu['label'] = isset($vals[$tkey]) ? $vals[$tkey] : $item;
            }

            //
            // categories
            //

            if ($item == 'categories') {

                foreach ($catsSorted as $c) {
                    if ($c['online'] > 0) {
                        $i = [
                            'type' => $item,
                            'category' => $c['category'],
                            'label' => $c['fullname'],
                            'rooms' => $c['rooms'],
                            'viewers' => $c['viewers'],
                            'link' => encodeUrl('webcamsCategory', $c)
                        ];

                        if ($dropdown) {
                            $menu['items'][] = $i;
                        }
                        else {
                            $links[] = $i;
                        }
                    }
                }
            }

            //
            // tags
            //

            elseif ($item == 'tags') {

                if ($varname == 'sidebarMenuItems' && $dropdown == 0) {
                    setTemplateValue('sidebarTags', 1);
                    $links[] = [ 'tags' => 1 ];
                }
                else {

                    // if not using the hardcoded logic in sidebar.php
                    // need to check if a category has been selected

                    if (!empty($url['args']['category'])) {
                        #$tags = getTemplateValue('catstags')[ $url['args']['category'] ];
                        $t = getTemplateValue('catstags');

                        if (!empty($t[ $url['args']['category'] ])) {
                            $tags = $t[ $url['args']['category'] ];
                        }
                        else {
                            $tags = getTemplateValue('tags');
                        }
                    }
                    else {
                        $tags = getTemplateValue('tags');
                    }

                    foreach ($tags as $c) {
                        if ($c['online'] > 0) {
                            $i = [
                                'type' => $item,
                                'label' => $c['fullname'],
                                'rooms' => $c['rooms'],
                                'viewers' => $c['viewers'],
                                'link' => encodeUrl('webcamsTag', $c)
                            ];

                            if ($dropdown) {
                                $menu['items'][] = $i;
                            }
                            else {
                                $links[] = $i;
                            }
                        }
                    }
                }
            }

            //
            // sort options
            //

            elseif ($item == 'sort') {
                foreach (explode(',', getTemplateValue('sortItems')) as $si) {
                    $tkey = 'sort' . ucfirst($si) . 'Label';

                    $i = [
                        'type' => $item,
                        'label' => isset($vals[$tkey]) ? $vals[$tkey] : $si,
                        'link' => $sortUrl . $si
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // videos
            //

            elseif ($item == 'videos') {
                foreach (explode(',', getTemplateValue('videosItems')) as $si) {
                    $tkey = 'videos' . ucfirst($si) . 'Label';
                    $urlName = $si == 'latest' ? 'videosIndex' : 'videos' . ucfirst($si);

                    $i = [
                        'type' => $item,
                        'label' => isset($vals[$tkey]) ? $vals[$tkey] : $si,
                        'link' => encodeUrl($urlName)
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // photos
            //

            elseif ($item == 'photos') {
                foreach (explode(',', getTemplateValue('photosItems')) as $si) {
                    $tkey = 'photos' . ucfirst($si) . 'Label';
                    $urlName = $si == 'latest' ? 'photosIndex' : 'photos' . ucfirst($si);

                    $i = [
                        'type' => $item,
                        'label' => isset($vals[$tkey]) ? $vals[$tkey] : $si,
                        'link' => encodeUrl($urlName)
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // sites
            //

            elseif ($item == 'sites') {
                foreach (explode(',', getConfig('webcams', 'sitesFilter', '')) as $f) {
                    $site = getSiteLongtName($f);
                    $labelName = 'site' . ucfirst($site) . 'Label';

                    if (!empty($vals[$labelName])) {
                        $label = $vals[$labelName];
                    }
                    else {
                        $label = $site;
                    }

                    $i = [
                        'type' => $item,
                        'label' => $label,
                        'link' => encodeUrl('webcamsSite', ['site' => $site])
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // gender
            //

            elseif ($item == 'gender') {
                foreach (explode(',', getTemplateValue('genderItems')) as $g) {
                    $name = getLongGender($g);
                    $tkey = 'gender' . ucfirst($name) . 'Label';

                    $i = [
                        'type' => $item,
                        'label' => isset($vals[$tkey]) ? $vals[$tkey] : $name,
                        'link' => $searchUrl . '&gender=' . $g
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // hair + age
            //

            elseif ($item == 'hair' || $item == 'age') {
                foreach (explode(',', getTemplateValue($item . 'Items')) as $ha) {
                    $tkey = $item . ucfirst($ha) . 'Label';
                    $tfilter = getTemplateValue($item . ucfirst($ha) . 'Filter');

                    $i = [
                        'type' => $item,
                        'label' => isset($vals[$tkey]) ? $vals[$tkey] : $ha,
                        #'link' => $searchUrl . '&' . $item . '=' . getTemplateValue($tfilter)
                        'link' => $searchUrl . $tfilter
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // body
            //

            elseif ($item == 'body') {
                foreach (explode(',', gettemplatevalue('bodyItems')) as $g) {
                    $tkey = 'body' . $g . 'Label';
                    $tfilter = getTemplateValue('body' . $g . 'Filter');

                    $i = [
                        'type' => $item,
                        'label' => isset($vals[$tkey]) ? $vals[$tkey] : $g,
                        'link' => $searchUrl . $tfilter
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // boobs
            //

            elseif ($item == 'boobs') {
                foreach (explode(',', gettemplatevalue('boobsItems')) as $g) {
                    $tkey = 'boobs' . $g . 'Label';
                    $tfilter = getTemplateValue('boobs' . $g . 'Filter');

                    $i = [
                        'type' => $item,
                        'label' => isset($vals[$tkey]) ? $vals[$tkey] : $g,
                        'link' => $searchUrl . $tfilter
                    ];

                    if ($dropdown) {
                        $menu['items'][] = $i;
                    }
                    else {
                        $links[] = $i;
                    }
                }
            }

            //
            // check for a category
            //

            elseif (!empty($counts['categories'][$item])) {
                $links[] = [
                    'type' => 'categories',
                    'label' => $counts['categories'][$item]['fullname'],
                    'rooms' => $counts['categories'][$item]['rooms'],
                    'viewers' => $counts['categories'][$item]['viewers'],
                    'link' => encodeUrl('webcamsCategory', ['category' => $item])
                ];
            }

            //
            // check for a tag
            //

            elseif (!empty($counts['tags'][$item])) {
                $links[] = [
                    'type' => 'tags',
                    'label' => $counts['tags'][$item]['fullname'],
                    'rooms' => $counts['tags'][$item]['rooms'],
                    'viewers' => $counts['tags'][$item]['viewers'],
                    'link' => encodeUrl('webcamsTag', ['tag' => $item])
                ];
            }

            //
            // new
            //

            elseif ($item == 'new' && (!isset($cats['new']) && !isset($tags['new']))) {
                $label = getTemplateValue('menuNewLabel');
                $links[] = [
                    'type' => $item,
                    'label' => empty($label) ? $item : $label,
                    'link' => $searchUrl . '&addedon=..7d'
                ];
            }

            //
            // check for a [urls] entry
            //

            elseif (!empty(getUrl($item))) {
                $label = getTemplateValue('menu' . ucfirst($item) . 'Label');
                $links[] = [
                    'type' => 'url',
                    'label' => empty($label) ? $item : $label,
                    'link' => encodeUrl($item)
                ];
            }

            //
            // webcams url or label
            //

            else {
                $wurl = 'webcams' . ucfirst($item);

                if (!empty($_AVOS['config']['urls'][$wurl])) {
                    $links[] = [
                        'type' => $item,
                        'label' => getTemplateValue('menu' . ucfirst($item) . 'Label'),
                        'link' => encodeUrl($wurl)
                    ];

                }
                elseif (preg_match('!\.(jpg|png|gif|webp)$!', $item)) {
                    $links[] = [
                        'type' => 'image',
                        'label' => $item
                    ];
                }
                else {
                    if ($item == 'hr') {
                        $item = '<hr>';
                    }

                    $links[] = [
                        'type' => 'label',
                        'label' => $item
                    ];
                }
            }

            //
            // append the dropdown
            //

            if ($dropdown) {
                $links[] = $menu;
            }
        }

        #echo "<pre>";print_r($links);exit;
        setTemplateValue($varname, $links);
        $cache[$varname] = $links;
    }

    $redis->set(\Avos\Redis\getPrefix('menuItems'), $cache);
    $redis->expire(\Avos\Redis\getPrefix('menuItems'), 60);
    }

    //
    // default to desktop items on mobile if not set
    //

    if (empty(getTemplateValue('headerMenuItemsMobile'))) {
        setTemplateValue('headerMenuItemsMobile', getTemplateValue('headerMenuItems'));
    }

    if (empty(getTemplateValue('sidebarMenuItemsMobile'))) {
        setTemplateValue('sidebarMenuItemsMobile', getTemplateValue('sidebarMenuItems'));
    }

    //
    // set webcamsProfilePerSite if webcamsProfileCb exists
    //

    \Avos\Utils\profFlag('set webcamsProfilePerSite');

    if (!empty(getUrl('webcamsProfileCb'))) {
        setTemplateValue('webcamsProfilePerSite', 1);
    }
    else {
        setTemplateValue('webcamsProfilePerSite', 0);
    }

    //
    // set default home route if empty
    //

    \Avos\Utils\profFlag('set homePagination');

    if (empty($vals['homePagination'])) {
        if (function_exists('array_key_first')) {
            setTemplateValue('homePagination', encodeUrl('webcamsCategory', ['category' => array_key_first($counts['categories']), 'page' => ':page']));
        }
        else {
            $t = reset($counts['categories']);
            setTemplateValue('homePagination', encodeUrl('webcamsCategory', ['category' => $t['category'], 'page' => ':page']));
        }
    }

    //
    // footer menu items
    //

    if (!empty($vals['footerMenuItems'])) {
        $items = [];

        foreach (explode(',', $vals['footerMenuItems']) as $i) {
            $internal = true;

            if (preg_match('!(.*):(.*)!', $i, $c)) {
                $label = $c[1];
                $link = $c[2];
            }
            else {
                $label = ucfirst($i);
                $link = $i;
            }
            if ($link[0] != '/') {
                $link = 'https://www.' . $link;
                $internal = false;
            }
            $items[] = [
                'label' => $label,
                'link' => $link,
                'internal' => $internal
            ];
        }

        setTemplateValue('footerMenuItems', $items);
    }

    //
    // users country code for geoblocking
    //

    setTemplateValue('usersCountry', strtolower(\geoip_country_code_by_name($_SERVER['HTTP_X_REAL_IP'])));
    #setTemplateValue('usersCountry', 'co');

    //
    // optional usersNickname page - requires words.txt+names.txt
    //

    $url = getUrl('webcamsNickname');
    if (!empty($url)) {
        setTemplateValue('useNicknamePage', 1);
    }
    else {
        setTemplateValue('useNicknamePage', 0);
    }


    \Avos\Utils\profFlag("layout() end");


        $sidebarModels = getWebcams('site=cb&status=f&count=3&gender=f');
       //$sidebarModels = array_merge($sidebarModels, getWebcams('site=cb|sc&status=g&count=2'));
        $sidebarModels = array_merge($sidebarModels, getWebcams('site=sc&status=f&count=6&gender=f'));
        shuffle($sidebarModels);
        setTemplateValue('sidebarModels', $sidebarModels);
    #add images preview

}

function getFeaturedModels($key = 'featuredModels')
{
    //
    // fetch featured models info to display at top of grids and for floating chat
    //

    $vals = getTemplateValues();

    if (!isset($vals[$key])) {
        return [];
    }

    $featured = [];
    #if (!empty($vals['models'])) {
        if (!empty($vals[$key])) {
            $WHERE = [];
            foreach (explode(',', $vals[$key]) as $m) {
                if (preg_match('!^(\w\w):([\w\-\_]+)$!', $m, $c)) {
                    $WHERE[] = "(site='$c[1]' AND nickname='$c[2]')";
                }
            }

            if (count($WHERE) > 0) {
                $WHERE = implode(' OR ', $WHERE);
                $featured = \Avos\Database\queryAssoc("SELECT * FROM webcams WHERE ($WHERE) AND status != 'o'");

                if (count($featured) > 0) {
                    foreach ($featured as $i => $model) {
                        $featured[$i]['featured'] = 1;
                        $featured[$i]['imagePath'] = \Avos\Utils\imagePath($model);
                        $featured[$i]['siteShortName'] = $model['site'];
                        $featured[$i]['siteShortNameCaps'] = ucfirst($model['site']);
                        $featured[$i]['site'] = \Avos\Scaffold\expandSiteName($model['site']);
                        $featured[$i]['status'] = \Avos\Scaffold\expandStatus($model['status']);
                        $featured[$i]['gender'] = \Avos\Scaffold\expandGender($model['gender']);
                        $featured[$i]['tags'] = str_replace(',', ', ', $model['tags']);
                        $featured[$i]['age'] = $model['age'] == 0 ? 18 : $model['age'];
                    }

                    if ($key == 'featuredModels' && !empty($vals['models'])) {
                        setTemplateValue('models', array_merge($featured, $vals['models']));
                    }
                }
            }
        }
    #}

    return $featured;
}

function setWebcamsMeta()
{
    \Avos\Utils\profFlag('setWebcamsMeta()');

    //
    // add in the profile titles for models to use in the grid and time online
    //

    $models = getTemplateValue('models');
    $offset = getConfig('templates', 'authorOffset', 0);

    if (is_array($models) && count($models) > 0) {
        $ids = [];

        foreach ($models as $i => $m) {
            $models[$i]['title'] = \Avos\Scaffold\author('profile:title', $m, 1, $m['id'] + $offset);
            $models[$i]['alttitle'] = \Avos\Scaffold\author('profile:title', $m, 1, $m['id'] + $offset + 1);
            $models[$i]['statusTime'] = 0;
            $ids[] = $m['id'];
        }

        // time online
        $t = \Avos\Database\queryAssoc('SELECT webcamsId, epochTime FROM history WHERE webcamsId IN ('.  implode(',', $ids) . ') GROUP BY webcamsId');
        $t2m = [];
        $now = time();

        foreach ($t as $m) {
            $m2t[$m['webcamsId']] = (int)(($now - $m['epochTime']) / 60);
        }

        foreach ($models as $i => $m) {
            if (isset($m2t[ $m['id'] ])) {
                $models[$i]['statusTime'] = $m2t[ $m['id'] ];
            }
            else {
                $models[$i]['statusTime'] = 0;
            }
        }

        setTemplateValue('models', $models);
    }

    //
    // need to embed the page title, description and keywords within the page
    //

    $words = \Avos\Utils\removeStopWords(getTemplateValue('title'));
    $words .= ' ,' . \Avos\Utils\removeStopWords(getTemplateValue('description'));
    $words .= ' ,' . \Avos\Utils\removeStopWords(getTemplateValue('keywords'));

    setTemplateValue('meta', explode(',', $words));
    setTemplateValue('metaCount', count(getTemplateValue('meta')));
    setTemplateValue('metaIndex', 0);

    \Avos\Utils\profFlag('setWebcamsMeta() end');
}

function hideFloatingChat()
{
    $_SESSION['floatingChatModel'] = -1;
    exit;
}

//
// to get the next meta snippet to put somewhere in the grid
//

function getNextMeta()
{
    $meta = getTemplateValue('meta');
    $count = getTemplateValue('metaCount');
    $index = getTemplateValue('metaIndex');

    if ($index < $count) {
        $r = 'alt="' . $meta[$index] . '"';
        setTemplateValue('metaIndex', $index+1);
        return $r;
    }
    else {
        return '';
    }
}

//
// if no data found
//

function notFound()
{
    if (preg_match('!\.(webp|jpg)$!', $_SERVER['REQUEST_URI'], $c)) {
        $ext = $c[1];
        header("Content-type: image/$c[1]");
        readfile(WEB . getTemplateValue('favIconUrl'));
        exit;
    }
    else {
        redirect('/');
    }
}

function webcamNotFound()
{
    redirect('/');
}

//
// modify the layout for the custom page
//

function webcamsMulti()
{
    webcamsCustom();
}

function webcamsMultiSearch()
{
    webcamsCustomSearch();
}

function webcamsCustom()
{
    #setTemplateValue('sidebar', 0);
    #setTemplateValue('headerMenuBurger', 0);
    setTemplateValue('gridSize', 'small');
    setTemplateValue('paginationLoadMore', getTemplateValue('customPaginationLoadMore'));
    setTemplateValue('models', getWebcams());

    $vals = getTemplateValues();
    $sortItems = [];

    foreach (explode(',', $vals['sortItems']) as $si) {
        $tkey = 'sort' . ucfirst($si) . 'Label';

        $sortItems[] = [
            'label' => isset($vals[$tkey]) ? $vals[$tkey] : $si,
            'value' => $si
        ];
    }

    setTemplateValue('sortItems', $sortItems);
    setWebcamsMeta();

    $offset = getConfig('templates', 'authorOffset', 0);
    $seed = (int)(crc32($_SERVER['SERVER_NAME'] . $_SERVER['REQUEST_URI']) / 10000) + $offset;
    setTemplateValue('keywords', implode(',', \Avos\Scaffold\author('profile:keywords', [], 8, $seed)));
}

function webcamsCustomSearch()
{
    #setTemplateValue('useLiveImages', 1);
    setTemplateValue('gridSizeSelectors', 0);
    setTemplateValue('paginationLoadMore', getTemplateValue('customPaginationLoadMore'));
}

//
// save last embedded model to the session
//

function webcamsCustomEmbed()
{
    $vals = getTemplateValues();
    $models = getWebcams(['site' =>  $vals['site'], 'nickname' => $vals['nickname']]);

    if (count($models) == 1) {
        $_SESSION['floatingChatModel'] = $models[0];
        setTemplateValue('model', $models[0]);
    }
}

function floatingChatEmbed()
{
    webcamsCustomEmbed();
}

//
// configurable homepage
//
// ; homeContent csv of types webcams,videos,photos
// homeContent = webcams
// ; homeFormat mixed or sections
// homeFormat = mixed
// ; homePagination url to link to for load more
// homePagination = /slutty/2
// ; webcams category
// homeWebcamsCategory = slutty
// ; category or type
// homeWebcamsCategoryType = category
// homeWebcams = 20
// homeVideos = 0
// homePhotos = 0
//

function home()
{
    global $_AVOS;

    $vals = getTemplateValues();

    if (!empty($vals['flavor']) && $vals['flavor'] == 'streamray') {
        if (!empty($vals['homeGender'])) {
            $_GET['gender'] = $vals['homeGender'];
        }
    }

    //
    // fetch data for each content type
    //

    $homeContent = explode(',', str_replace(' ',  '', $vals['homeContent']));

    if ($vals['homePhotos'] > 0) {
        setTemplateValue('photos', getPhotos(['count' => $vals['homePhotos']]));
    }
    else {
        setTemplateValue('photos', []);
    }

    if ($vals['homeVideos'] > 0) {
        setTemplateValue('videos', getVideos(['count' => $vals['homeVideos']]));
    }
    else {
        setTemplateValue('videos', []);
    }

    if ($vals['homeWebcams'] > 0) {
        $_AVOS['page']['type'] = 'webcams';
        setTemplateValue('models', getDefaultWebcams());

        // save them so we know which to not randomize
        $featured = getFeaturedModels();

        // need to grab profile titles
        setWebcamsMeta();
    }
    else {
        setTemplateValue('models', []);
    }

    //
    // single content type
    //

    if (count($homeContent) == 1) {
        if ($homeContent[0] == 'webcams' || $homeContent[0] == 'videos' || $homeContent[0] == 'photos') {
            setTemplateValue('homeTemplate', $homeContent[0] . 'Index.php');
        }
        else {
            setTemplateValue('homeTemplate', $homeContent[0] . '.php');
        }

        return;
    }

    //
    // normalise cell fields
    //

    \Avos\Utils\profFlag('home data mixing');

    $cells = [];
    $videos = getTemplateValue('videos');
    $photos = getTemplateValue('photos');
    $webcams = getTemplateValue('models');

    foreach ($videos as $i => $cell) {
        $videos[$i]['imageUrl'] = $cell['imagePath'] . $cell['mainThumb'] . '.webp';
        $videos[$i]['link'] = encodeUrl('videosPlayer', $cell);
        $videos[$i]['subject'] = $cell['description'];
        $cells[] = $videos[$i];
    }

    foreach ($photos as $i => $cell) {
        $photos[$i]['imageUrl'] = $cell['imagePath'] . $cell['mainThumb'] . '.webp';
        $photos[$i]['link'] = encodeUrl('photosGallery', $cell);
        $photos[$i]['subject'] = $cell['description'];
        $cells[] = $photos[$i];
    }

    foreach ($webcams as $i => $cell) {
        $webcams[$i]['imageUrl'] = $cell['imagePath'] . $cell['numImages'] . '.webp';
        $webcams[$i]['title'] = $cell['nickname'];

        if (!empty($vals['webcamsProfilePerSite'])) {
            $webcams[$i]['link'] = encodeUrl('webcamsProfile' . $cell['siteShortNameCaps'], $cell);
        }
        else {
            $webcams[$i]['link'] = encodeUrl('webcamsProfile', $cell);
        }

        $cells[] = $webcams[$i];
    }

    //
    // iterate thru each homeContent
    //

    $sections = [];
    $lastSectionType = false;
    $i = 0;

    foreach ($homeContent as $c) {
        switch ($c) {
            case 'photos':
            case 'videos':
            case 'webcams':
                if (!$lastSectionType || $vals['homeFormat'] == 'sections') {
                    $sections[] = [ 'type' => $c, 'cells' => $$c, 'title' => getTemplateValue('home' . ucfirst($c) . 'Title') ];
                    $lastSectionType = true;
                    $i++;
                }
                else {
                    $sections[$i-1]['type'] = 'mixed';
                    $sections[$i-1]['cells'] = array_merge($sections[$i-1]['cells'], $$c);
                    if ($vals['homeFormat'] == 'mixed') {

                        // leave featured models at the start

                        $featured = array_slice($sections[$i-1]['cells'], 0, count($featured));
                        $normals = array_slice($sections[$i-1]['cells'], 1);
                        shuffle($normals);
                        $sections[$i-1]['cells'] = array_merge($featured, $normals);
                    }
                }
                break;

            default:
                $sections[] = [ 'type' => 'template', 'template' => $c . '.php' ];
                $lastSectionType = false;
                $i++;
        }
    }

    /*
    //
    // mixed format
    //

    if ($vals['homeFormat'] == 'mixed') {
        shuffle($cells);
        setTemplateValue('sections', [[ 'type' => 'mixed', 'cells' => $cells ]]);
        return;
    }

    //
    // only other format type is sections
    //

    $sections = [];

    foreach ($homeContent as $c) {
        #$type = $c == 'webcams' ? 'models' : $c;
        $sections[] = [ 'type' => $c, 'cells' => $$c, 'title' => getTemplateValue('home' . ucfirst($c) . 'Title') ];
    }
*/

    setTemplateValue('sections', $sections);
}

function webcamsProfileCb() { webcamsProfile(); }
function webcamsProfileBc() { webcamsProfile(); }
function webcamsProfileSc() { webcamsProfile(); }
function webcamsProfileCs() { webcamsProfile(); }

function webcamsCategory1() { webcamsCategory(); }
function webcamsCategory2() { webcamsCategory(); }
function webcamsCategory3() { webcamsCategory(); }
function webcamsCategory4() { webcamsCategory(); }
function webcamsCategory5() { webcamsCategory(); }
function webcamsCategory6() { webcamsCategory(); }

function webcamsCategory()
{
    saveSearch(getTemplateValue('category'));
}

function webcamsTag()
{
    saveSearch(getTemplateValue('tag'));
}

function getDefaultWebcams()
{
    $category = getTemplateValue('homeWebcamsCategory');
    $categoryType = getTemplateValue('homeWebcamsCategoryType');

    if (empty($categoryType) || $categoryType == 'category') {
        $categoryType = 'category';
        $cats = getCategories();
    }
    else {
        $cats =  getTags();
    }

    foreach ($cats as $name => $c) {
        return getWebcams([$categoryType => $name]);
    }
}

//
// for sitemaps
//

function webcamsProfileFn($m)
{
        $url = getUrl('webcamsProfileCb');

    if (!empty($url)) {
        return encodeUrl('webcamsProfile' . ucfirst(getSiteShortName($m['site'])), $m);
    }
    else {
        return encodeUrl('webcamsProfile', $m);
    }
}

//
// profile page
//

function webcamsProfile()
{
    global $_AVOS;

    $model = getTemplateValue('model');
    $url = getTemplateValue('url');

    if (!empty($model['blocked']) && in_array(getTemplateValue('usersCountry'), $model['blocked'])) {
        redirect('/');
    }

    /*
    if (getConfig('templates', 'webcamsProfilePerSite') && $url['name'] == 'webcamsProfile') {
        redirect(encodeUrl('webcamsProfile' . $model['siteShortNameCaps'], $model));
        exit;
    }
     */

    $relatedType = getConfig('webcams', 'relatedType', 'categories');
    $relatedCSV = getConfig('webcams', 'related', '');
    $relatedCount = getConfig('webcams', 'relatedCount', 24);

    if (empty($relatedCSV)) {

        $cats = getTemplateValue('cats');
        $tags = getTemplateValue('tags');

        if ($relatedType == 'categories') {
            $t = array_merge(array_keys($tags), array_keys($cats));
        }
        else {
            $t = array_merge(array_keys($cats), array_keys($tags));
        }

        $relatedCSV = implode(',', $t);
    }

    //$relatedCatsTags = getTemplateValue('sidebarCatsTags');
    $relatedCatsTags = empty(getUrl('webcamsCategoryTag')) ? 0 : 1;
    setTemplateValue('related', getRelatedWebcams($relatedCSV, intval($relatedCount), $relatedType, $relatedCatsTags));

    if ($model['status'] != 'Offline') {
        $_SESSION['floatingChatModel'] = $model;
        #echo "setting";print_r($model);exit;
    }
    else {
        unset($_SESSION['floatingChatModel']);
    }

	if ($model['numImages'] > 0) {
		$webDir = rtrim(getConfig('site')['webDir'], '/');
		$i = $model['numImages'];
		while ($i > 0 && !file_exists($webDir . ($img = $model['imagePath'] . $i . '.webp'))) $i--;

		if ($i > 0) {
			$size = getimagesize($webDir . $img);
			setTemplateValue('previewImg', rtrim(getConfig('site')['url'], '/') . $img);
			setTemplateValue('previewImgWidth', $size[0]);
			setTemplateValue('previewImgHeight', $size[1]);
		}
	}

    $offset = getConfig('templates', 'authorOffset', 0);
    $title = \Avos\Scaffold\author('profile:title', $model, 1, $model['id'] + $offset);
    setTemplateValue('title', $title);

    $keywords = implode(',', \Avos\Scaffold\author('profile:keywords', $model, 8, $model['id'] + $offset));
    setTemplateValue('keywords', $model['nickname'] . ',' . $model['site'] . ',' . $keywords);

    $description = \Avos\Scaffold\author('profile:description', $model, 1, $model['id'] + $offset);
    setTemplateValue('description', $description);

    //
    // turn tags into array
    //

    $tags = [];
    foreach (explode(',', trim($model['tags'])) as $t) {
        if (!empty($t)) {
            $tags[] = [
                'name' => trim($t),
                'keywords' =>  str_replace(' ', '*', trim(\Avos\Utils\removeStopWords($t)))
            ];
        }
    }
    $model['tags'] = $tags;
    setTemplateValue('model', $model);

    //
    // get the heatmap
    //

    //setTemplateValue('heatmap', getHeatmap($model));
    #echo $model['id'];exit;
    #$history = \Avos\Redis\getHistory($model['id']);
    #echo "<pre>";print_r($history);exit;

    //
    // increment view counter
    //

    $redis = \Avos\Redis\handle();
    $key = $model['id'] . '/p';
    $redis->hIncrBy($key, 'views', 1);
    #echo "<pre>";print_r($model);exit;
}

function webcamsSite()
{
    global $_AVOS;

    $site = getUrlMatched()['args']['site'];
    $rules = $_AVOS['page']['metaRules'];

    $found = 0;
    foreach ($rules as $r) {
        if (strpos($r, $site) !== false) {
            $found = 1;
        }
    }

    $offset = getConfig('templates', 'authorOffset', 0);
    $seed = (int)(crc32($site) / 10000) + $offset;

    setTemplateValue('title', \Avos\Scaffold\author('category:title', [ 'category' => ucfirst($site) ], 1, $seed));
    setTemplateValue('description', \Avos\Scaffold\author('category:description', [ 'category' => ucfirst($site) ], 1, $seed));
    setTemplateValue('keywords', implode(',', \Avos\Scaffold\author('category:keywords', [ 'category' => strtolower($site) ], 8, $seed)));
}

//
// save search keyword to redis
//

function search()
{
    global $_AVOS;

    $keyword = '';

    foreach (['kw', 'q', 'search'] as $k) {
        if (isset($_GET[$k])) {
            $keyword = $_GET[$k];
        }
    }

    // if the keyword is the name of a cat or tag then send to it

    \Avos\Utils\profFlag("getWebcamsCounts()");
    $counts = getWebcamsCounts();

    if (!empty($counts['categories'][$keyword])) {
        $_GET = [];
        redirect(encodeUrl('webcamsCategory', ['category' => $keyword]));
    }
    elseif (!empty($counts['tags'][$keyword])) {
        $_GET = [];
        redirect(encodeUrl('webcamsTag', ['tag' => $keyword]));
    }

    // save search
    saveSearch($keyword);

    // check we have some results

    $keyword = str_replace('*', ' ', $keyword);

    if (count(getTemplateValue('models')) == 0) {
        #setTemplateValue('models', $counts[getTemplateValue('homeWebcamsCategoryType')][getTemplateValue('homeWebcamsCategory')]['models']);
        #setTemplateValue('models', getWebcams([getTemplateValue('homeWebcamsCategoryType') => getTemplateValue('homeWebcamsCategory')]));
        setTemplateValue('models', getDefaultWebcams());
        setTemplateValue('title', str_replace(':keyword', $keyword, getTemplateValue('searchTitleNotFound')));
        setWebcamsMeta();
    }
    elseif (!empty($keyword)) {
        setTemplateValue('title', str_replace(':keyword', $keyword, getTemplateValue('searchTitle')));
    }
    else {
        setTemplateValue('title', '');
    }
}

function saveSearch($keyword)
{
    if (empty($keyword)) {
        return;
    }

    $key = \Avos\Redis\getPrefix('searches');
    $redis = \Avos\Redis\handle();
    $keyword = preg_replace('!\W!', '', $keyword);

    if (strlen($keyword) > 16) {
        $keyword = substr($keyword, 0, 16);
    }

    $redis->hIncrBy($key, $keyword, 1);
}

//
// create search cloud
//

function webcamsSearches()
{
    /*
    if (!getTemplateValue('webcamsSearchCloud')) {
        return;
    }
     */

    $redis = \Avos\Redis\handle();

    //
    // see if we have a processed cached version
    //


    $cacheKey = \Avos\Redis\getPrefix('searchesProcessed');
    $searches = $redis->get($cacheKey);

    if (!empty($searches)) {
        setTemplateValue('searchCloud', $searches);
        return;
    }

    //
    // process the raw search data
    //

    $key = \Avos\Redis\getPrefix('searches');
    $searches = $redis->hGetAll($key);

    if (empty($searches)) {
        setTemplateValue('searchCloud', $searches);
        return;
    }

    /*
	// find max value
	$max = 0;
	foreach ($searches as $k => $v) {
		if ($v > $max) {
			$max = $v;
        }

        // delete short searches
        if (strlen($k) < 3 || $v < 3) {
            unset($searches[$k]);
        }
    }
     */

    arsort($searches);
    $max = reset($searches);
    #$minFac = getTemplateValue('webcamsSearchCloudDisplayMin');
    #$minFac = $minFac ? $minFac : 0.1;
    #$min = $max * $minFac;
    $searches = array_splice($searches, 0, 40);

    // normalise to 255 for color and 24 for font size
    $ret = [];
    foreach ($searches as $k => $v) {
        $ret[$k] = array(
            'count' => $v,
            'hex' => dechex(55 + ($v / $max * 200)),
            'dec' => 55 + ($v / $max * 200),
            'size' => 10 + ($v / $max * 24),
            'weight' => (int)(($v / $max * 10) + 1)
        );
    }

    \Avos\Utils\shuffle_assoc($ret);
    setTemplateValue('searchCloud', $ret);

    $redis->set($cacheKey, $ret);
    $redis->expire($cacheKey, 600);
}

function webcamsRandom()
{
    $webcams = getWebcams("site=cb&status=f&gender=f&count=1000");
    $idx = array_rand($webcams);
    $model = $webcams[$idx];
    $url = webcamsProfileFn($model);
    redirect($url);
}

function webcamsTagspage()
{
    $tags = array();
    $thumbs = getTemplateValue('tagsPageThumbs');

    foreach (getTemplateValue('tags') as $name => $stats) {
        $tags[] = array(
            'tag' => $name,
            'viewers' => $stats['viewers'],
            'rooms' => $stats['online'],
            'models' => array_splice($stats['models'], 0, $thumbs)
        );
    }

    setTemplateValue('tagsSummary', $tags);
}

function webcamsDiscover()
{
    $sections = array();
    $counts = getTemplateValue('counts');
    $thumbs = getTemplateValue('discoverPageThumbs');

    foreach (explode(',', getTemplateValue('discoverPageSections')) as $e) {

        if (isset($counts['categories'][$e])) {
            $sections[] = [
                'name' => $counts['categories'][$e]['fullname'],
                'online' => $counts['categories'][$e]['online'],
                'viewers' => $counts['categories'][$e]['viewers'],
                'link' => encodeUrl('webcamsCategory', $counts['categories'][$e]),
                'models' => array_splice($counts['categories'][$e]['models'], 0, $thumbs)
            ];
        }
        elseif (isset($counts['tags'][$e])) {
            $sections[] = [
                'name' => '#' . $counts['tags'][$e]['fullname'],
                'online' => $counts['tags'][$e]['online'],
                'viewers' => $counts['tags'][$e]['viewers'],
                'link' => encodeUrl('webcamsTag', $counts['tags'][$e]),
                'models' => array_splice($counts['tags'][$e]['models'], 0, $thumbs)
            ];
        }
        elseif (isset($counts['sites'][$e])) {
            $sections[] = [
                'name' => $counts['sites'][$e]['fullname'],
                'online' => $counts['sites'][$e]['online'],
                'total' => $counts['sites'][$e]['total'],
                'link' => encodeUrl('webcamsSite', $counts['sites'][$e]),
                'models' => array_splice($counts['sites'][$e]['models'], 0, $thumbs)
            ];
        }
    }

    setWebcamsMeta();
    setTemplateValue('sections', $sections);
    return $sections;
}

function webcamsNickname()
{
    $key = \Avos\Redis\getPrefix('wordlists');
    $redis = \Avos\Redis\handle();

    if ($redis->type($key) == \Redis::REDIS_NOT_FOUND) {

        if (!file_exists(TOP . 'words.txt')) {
            setTemplateValue('models', []);
            return;
        }

        $redis->set($key, [
            'words' => file(TOP . 'words.txt'),
            'names' => file(TOP . 'names.txt')
        ]);

        $_AVOS['redis']->expire($key, 3600);
    }

    $lists = $redis->get($key);
    $nickname = strtolower(getUrl()['args']['nickname']);
    $filter = [];

    foreach (['words', 'names'] as $e) {
        foreach ($lists[$e] as $w) {
            $w = strtolower(trim($w));
            if (strlen($w) > 3 && strlen($w) < 8) {
                if (strpos($nickname, $w) !== false) {
                    $filter[] = 'nickname=~' . $w;
                }
            }
        }
    }

    $url = getTemplateValue('url');

    if (count($filter) > 0) {
        $online = getWebcams(implode('&', $filter));
        $models = $online;

        if (!empty($url['args']['_offline'])) {
            $offline = getWebcams(implode('&', $filter) . '&sort=newest&status=!x&count=500', '', '', 'Archive');

            $onlineNicknames = [];
            foreach ($online as $m) {
                $onlineNicknames[$m['site'] . $m['nickname']] = 1;
            }

            foreach ($offline as $m) {
                if (!isset($onlineNicknames[$m['site'] . $m['nickname']])) {
                    $models[] = $m;
                }
            }
        }

        setTemplateValue('models', $models);
    }

    setWebcamsMeta();
}

//
// video player
//

function videosPlayer()
{
	global $_AVOS;
	$video = getTemplateValue('video');
    setTemplateValue('related', getRelatedVideos());

	$img = $video['imagePath'] . $video['mainThumb'] . '.webp';
	$size = getimagesize(rtrim(getConfig('site')['webDir'], '/') . $img);
	setTemplateValue('previewImg', rtrim(getConfig('site')['url'], '/') . $img);
	setTemplateValue('previewImgWidth', $size[0]);
	setTemplateValue('previewImgHeight', $size[1]);
}

//
// photo gallery
//

function photosGallery()
{
	global $_AVOS;
	$photos = getTemplateValue('photos');
    setTemplateValue('related', getRelatedPhotos());

	$img = $photos['imagePath'] . $photos['mainPhoto'] . '.jpg';
	$size = getimagesize(rtrim(getConfig('site')['webDir'], '/') . $img);
	setTemplateValue('previewImg', rtrim(getConfig('site')['url'], '/') . $img);
	setTemplateValue('previewImgWidth', $size[0]);
	setTemplateValue('previewImgHeight', $size[1]);
}

function country()
{
    $code = \geoip_country_code_by_name($_SERVER['HTTP_X_REAL_IP']);
    $kw = str_replace([',', ' '], ['*', ''], \Avos\Utils\countryCode($code) . ',' . \Avos\Utils\languageCode($code));
    setTemplateValue('models', getWebcams(['kw' => $kw, 'page' => getTemplateValue('page')]));
}

function authorOld()
{
    return [
        'start' => [
            'title' => [
                '%Try% Free %Webcams% - %sexy% adult', '%Try% the best %category% adult %webcams%'
            ],
            'category:title' => [
                '%Try% %Sexy% %Category% webcams', '%Try% Free %Category% %Webcams%', '%Try% the best %category% adult %webcams%',
                '%Try% %Category% Freechat %Webcams% %Site%', '%Try% %Category% %sexy% Webcams', '%Try% %sexy% %category% %webcams%'
            ],
            'category:description' => [
                '%Try% %best% %category% %webcams%. %Sexy% %sexy% Free %Models%.'
            ],
            'category:keywords' => [
                'ass, anal, anal cams, adult sex, butt-centric xxx, anal porn, adult webcams free cams, free adult video chat, free sex webcams, live adult cams, free sex webcams, adult webcams, free live porn'
            ],
            'profile:title' => [
                '%Sexy% %nickname% from %Site%', '%Site% %Nickname%', '%Try% %age% years old %nickname% from %Site%',
                "%Try% %Site%'s %Nickname%", '%Try% %sexy% %model% %Nickname%', '%Sexy% %Nickname% wants you to fuck %hisher% body now',
                '%Try% %Nickname%, %heshe% wants to masturbate for you'
            ],
            'category:keywords' => [
                '%category:keywords%'
            ]
        ],
        'rewrite' => [
            'any' => [
                'site' => [ '', '%sitename%' ],
                'sexy' => [ '', 'sexy', 'naked', 'slutty', 'cute', 'sweet' ],
                'online' => [ 'online', 'freechat', 'naked' ],
                'try' => [ '', '', '', 'try', 'discover', 'explore', 'masturbate to', 'watch' ],
                'webcams' => [ 'chat', 'webcams', 'cams', 'webcam shows', '%online% %models%' ],
                'models' => [ 'models', 'performers', 'cams' ],
                'model' => [ 'model', 'slut', 'escort', 'camwhore', 'cumslut', 'stripper', 'performer' ],
                'best' => [ 'best', 'most awesome', '%sexy%' ]
            ]
        ]
    ];
}
