/*
 * :site/:nickname will be appended to embedUrl so define a rule like:
 * customEmbed = [ none, "/embed/:site/:nickname", "layout=0" ]
 *
 * layout=0 will be appended to searchUrl to prevent the template being
 * wrapped within layout.php
 */

var embedUrl = '/embed/';
var searchUrl = '/search/';
var gridCellClass = 'model_icon';

var customFilter = {};

function refreshFilter()
{
    var req = searchUrl + '?';
    var i=0;

    for (var k in customFilter) {
        if (customFilter[k] != '') {
            if (i++ > 0) req += '&';
            req += customFilter[k];
        }
    }

    req += '&layout=0';
    loadSearch(req);
}

function addFilter(key, value)
{
    customFilter[key] = value;
    refreshFilter();
    return false;
}

function removeFilter(key, value)
{
    customFilter[key] = '';
    refreshFilter();
    return false;
}

function loadSearch(req)
{
    var first = true;
    $('#customList').load(req, function(html) {
        $('#customList').find('.model_icon').each(function(e) {
            if (first) {
               var site = $(this).data('site');
               var nickname = $(this).data('nickname');
               $('#customChatEmbed').load(embedUrl + site + '/' + nickname);
               first = false;
            }
            $(this).click(function() {
                var site = $(this).data('site');
                var nickname = $(this).data('nickname');
                $('#customChatEmbed').load(embedUrl + site + '/' + nickname);
                return false;
            });
        });
    });
}
