<style>
.model-grid {
    display: grid;
    grid-template-columns: repeat(auto-fill, minmax(280px, 1fr));
    gap: 24px;
    padding: 20px;
    justify-items: center;
    /* Added align-items to ensure items are aligned at the top */
    align-items: start;
}

.model-card {
    position: relative;

    border-radius: 12px;
    box-shadow: 0 8px 16px rgba(0, 0, 0, 0.1);
    overflow: hidden;
    transition: transform 0.3s ease, box-shadow 0.3s ease;
    width: 100%;
}

.model-card:hover {
    transform: translateY(-10px);
    box-shadow: 0 16px 32px rgba(0, 0, 0, 0.2);
}

.model-card-header {
    align-items: center;
    background: #414141;
    border-radius: 4px;
    color: #d4d4d4;
    font-weight: 700;
    height: 40px;
    justify-content: center;
    line-height: 40px;
    margin: 15px 0 10px;
    position: relative;
    text-align: center;
    display: flex;
    flex-direction: row;
    font-size: .75rem
}





.model-link {
    display: block;
    position: relative;
    overflow: hidden;
}

.model-thumbnail-wrapper {
    position: relative;
    width: 100%;
    padding-top: 75%; /* Aspect ratio 4:3 */
}

.model-thumbnail {
    position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    height: 100%;
    object-fit: cover;
    transition: transform 0.3s ease;
}

.model-card:hover .model-thumbnail {
    transform: scale(1.1);
}

.model-nickname {
    position: absolute;
    bottom: 0px;
    font-size: 12px;
    font-weight: 900;
    width: 100%;
    z-index: 1;
    height: 30px;
    margin: 0;
    opacity: 0.5;
    max-width: 100%;
    padding: 1px 0 0 9px;
    text-shadow: 0 1px 2px rgba(0, 0, 0, .3);
    background: black;
    overflow: hidden;
    color: white;
    text-overflow: ellipsis;
    white-space: nowrap;
    letter-spacing: .063rem;
}




.model-nickname .nickname {
    color: #FF6347; /* Example style for nickname */
    font-weight: bold;
}

.model-nickname .status {
    color: #FFD700; /* Example style for status */
    font-style: italic;
}

.model-card-header.first {
    background-color: #FEB601; /* Gold background for first place */
    color: black;
}

.model-card-header.second {
    background-color: #D5E0E9; /* Silver background for second place */
    color: black;
}

.model-card-header.third {
    background-color: #EC8461; /* Bronze background for third place */
    color: black;
}

.model-card-header .model-position {
    
    font-size: 12px;
}

.model-card-header .model-viewers {
    color: gray;
}




.ModelThumbLower\#X3 {
    align-items: center;
    bottom: 8px;
    -moz-column-gap: 4px;
    column-gap: 4px;
    display: flex;
    flex-wrap: nowrap;
    left: 8px;
    position: absolute;
    right: 8px;
    z-index: 1
}
.ModelThumbSide\#kM {
    -moz-column-gap: 4px;
    column-gap: 4px;
    display: flex;
    overflow: hidden;

}
.ModelThumbUsername\#qC {
    align-self: center;
    color: #fff;
    font-size: 1.35rem;
    font-weight: 500;
    margin: 0;
    max-width: 100%;
    padding: 1px 0;
    text-shadow: 0 1px 2px rgba(0, 0, 0, .3);
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    letter-spacing: .063rem;
}
/* General Styles */
.page-header-description {
    text-align: center;
    padding: 30px 20px;
    background-color: <?= $tabsCategoriesMenuBackground?>;  /* Light background color */
    border-radius: 8px;
    box-shadow: 0 4px 6px rgba(0, 0, 0, 0.1);
    margin: 20px 0;
}

.best-models-title {
    font-size: 25px;
    font-weight: 700;
    color: <?= $tabsCategoriesMenuColor?>;
    margin-bottom: 15px;
    text-transform: uppercase;
    letter-spacing: 1px;
    line-height: 1.2;
}

.page-sub-header {
    font-size: 18px;
    color: #555;
    line-height: 1.8;
    max-width: 100%;
    margin: 0 auto;
    padding: 0 20px;
    font-family: 'Arial', sans-serif;
}

.ranked-description {
    font-size: 16px;
    color: <?= $tabsCategoriesMenuColor?>;;
    line-height: 1.8;
    margin-top: 10px;
}

.ranked-description strong {
    color: <?= $pageTextDescription?>;  /* Highlight important text */
}

/* Responsive Styles */
@media (max-width: 768px) {
    .page-header-description {
        padding: 20px;
    }

    .best-models-title {
        font-size: 28px;
        margin-bottom: 10px;
    }

    .page-sub-header {
        font-size: 16px;
        padding: 0 15px;
    }

    .ranked-description {
        font-size: 14px;
    }
}

/* Mobile-first improvements */
@media (max-width: 480px) {
    .best-models-title {
        font-size: 24px;
        line-height: 1.3;
    }

    .page-sub-header {
        font-size: 14px;
        padding: 0 10px;
    }

    .ranked-description {
        font-size: 13px;
    }
}
/* Status Label Styles */
.status-label {
    position: absolute;
    top: 10px;
    left: 10px;
    z-index: 1;
    font-size:9px;
    padding: 5px 10px;
    color: black;
    font-weight: bold;
    border-radius: 3px;
}

/* Specific Background Colors */
.status-live {
    background-color: #28a745;
}

.status-spy {
    background-color: purple;
}

.status-show {
    background-color: orange;
}

.status-offline {
    background-color: #cccccc;
}
.status-away{
    background-color: firebrick;
}

</style>


<?php
// Mapping of site abbreviations to full names
$siteMapping = [
    'bc' => 'BongaCams',
    'cb' => 'Chaturbate',
    'cs' => 'CamSoda',
    'ff' => 'Flirt4Free',
    'sc' => 'StripChat',
    'sr' => 'Streamray',
    'lj' => 'LiveJasmin',
    'sm' => 'Streamate',
    'il' => 'ImLive',
    'so' => 'SoulCams',
    'cr' => 'Cherry',
    'xc' => 'xCams',
    'c4' => 'Cam4',
    'xl' => 'xLove',
    'mf' => 'MyFreeCams',
    'am' => 'Amateur',
];


// Convert the string to an array, trimming whitespace
$siteCodes = array_map('trim', explode(',', $popularDisplaySites));

// Convert the site codes into full names
$siteNames = array_map(function ($site) use ($siteMapping) {
    return $siteMapping[$site] ?? $site; // Use full name or fallback to code if not found
}, $siteCodes);

// Format the text
$siteText = implode(', ', $siteNames);
?>




<div class="page-header-description">
    <div class="page-header">
        <h2 class="best-models-title text-title-l1 title-ds">Top <?= $popularModelsMax ?> Live Cam Models - Popular & Most Viewed</h1>
    </div>
    <div class="page-sub-header">
    <p class="ranked-description">Ranked by total <strong>StripPoints</strong> earned, these models represent the top talent from <strong><?= $siteText ?></strong>. Our rankings showcase the most popular, talented, and captivating performers. Meet the <strong>elite models</strong> who are heating up the scene!</p>

       
</div>
</div>






         <div class="model-grid">

<?php


$position = 1; 
foreach ($models as $i => $m) {



    
    // Map status abbreviations to full terms and label styles
    $statusText = '';
    $statusClass = '';
    
    if ($m['status'] === 'Offline') {
        $statusText = 'Offline';
        $statusClass = 'status-offline';
    } elseif ($m['status'] === 'Freechat') {
        $statusText = 'Live Show';
        $statusClass = 'status-live';
    } elseif ($m['status'] === 'Private') {
        $statusText = 'Spy Cam';
        $statusClass = 'status-spy';
    } elseif ($m['status'] === 'Group') {
        $statusText = 'On Show';
        $statusClass = 'status-show';
    } elseif ($m['status'] === 'Away') {
        $statusText = 'On Demand';
        $statusClass = 'status-away';
    }
?>

<div class="model-card">
    <div class="model-card-header <?= ($position == 1) ? 'first' : (($position == 2) ? 'second' : (($position == 3) ? 'third' : '')) ?>">
        <div class="model-position">
            <?= $position ?>th Place
        </div>
        - &nbsp;
        <div class="model-position"><?= $m['viewers'] ?> viewers</div>
    </div>

  
    <div class="ModelThumbLower#X3">
        <div class="ModelThumbSide#kM">
            <span class="ModelThumbUsername#qC"><?= $m['nickname'] ?>-</span>
        </div>
        <div class="ModelThumbSide#kM ModelThumbSide__right#P5"></div>
    </div>

    <a href="<?= strtolower(encodeUrl('webcamsProfile' . ($webcamsProfilePerSite == 1 ? $m['siteShortNameCaps'] : ''), $m)); ?>" class="model-link">
        <div class="model-thumbnail-wrapper">
              <!-- Status Label at the Top Left Corner -->
    <div class="status-label <?= $statusClass ?>"><?= $statusText ?></div>

            <img src="<?= ($m['numImages'] > 0 && empty($useLiveImages)) ? $m['imagePath'] . $m['numImages'] . '.webp' : $m['imageUrl'] ?>" class="model-thumbnail" alt="<?= $m['nickname'] ?> from <?= $m['site'] ?>">
        </div>
    </a>
</div>

<?php
    $position++; 
}
?>






